<?php
class ServerSyncCommand extends CConsoleCommand {

    private $aliveTestFile = 'md5.txt';
    private $proxyInfoFile = 'commands/shell/host_info';
    private $sshKeyFile = 'commands/shell/proxy_user.key';
    private $CorpIdInformationID = 0x10;
    private $ProxyMgrInformationID = 0x11;
    private $yunServerHost = 'appcloud.idste.org';
    private $yunServerUrl = 'https://appcloud.idste.org/';
    public $proxyId = -1;
    public $proxyHost = "";
    public $proxyPort = 0;

    private function ProxyConnect(){
        $proxyCmd = "ps aux | grep 'ssh -i " . $this->sshKeyFile . "' | awk '{print $2}' | xargs kill -9";
        shell_exec($proxyCmd);
        $proxyCmd = 'ssh -i '. $this->sshKeyFile .' -o ServerAliveInterval=60 -o ServerAliveCountMax=3 ';
        $proxyCmd .= '-o StrictHostKeyChecking=no -NfR ';
        $proxyCmd .= $this->proxyPort .':localhost:80 proxy_user@'. $this->proxyHost;
        system($proxyCmd . ' > /dev/null &');
    }

    private function SaveProxyInfo($postResult){
        $cmd = "echo '".$postResult."'> ". $this->proxyInfoFile;
        shell_exec($cmd);
        $cmd = 'echo ' . time() . md5($postResult). ' > ../md5.txt';
        shell_exec($cmd);
    }

    private function ProxyServerTest(){
        $cmd = 'ping -c 1 ' . $this->yunServerHost;
        $ret = shell_exec($cmd);
        if(empty($ret))
            return false;
        else
            return true;
    }

    private function GetProxyMgrServer(){
        $update = true;
        $sql = 'SELECT * FROM BaseInfo WHERE InfomationID = '. $this->CorpIdInformationID;
        $data = DBMethodUtils::findData( $sql);
        if (!empty ( $data )) {
            if(!empty($item['Description'])){
                $this->yunServerHost = $item['Description'];
                $this->yunServerUrl = 'https://' . $this->yunServerHost . '/';
                $update = false;
            }
        }
        if($update) {
            $sql = 'INSERT INTO BaseInfo(InfomationID, Description) VALUES(:InfomationID, :Description)';
            $sql .= 'on duplicate key update InfomationID=VALUES(InfomationID), Description=VALUES(Description)';
            DBMethodUtils::RunSql ( $sql, array(':InfomationID' => $this->CorpIdInformationID, ':Description' =>$this->yunServerHost) );
        }
    }

    private function SendAliveMsg(){
        $sql = 'SELECT * FROM BaseInfo WHERE InfomationID=0';
        $data = DBMethodUtils::findData( $sql);
        if (!empty ( $data )) {
            $postdata['School']['name'] = $data['Description'];
        }
        else {
            $postdata['School']['name'] = 'unset_name_';
        }
        $postdata['id'] = $this->proxyId;
        $url = $this->yunServerUrl . 'index.php?r=school/alive';
        $result = NetToolUtil::PostData ( $url, http_build_query ( $postdata, '', '&' ) );
    }

    /**
     * 向代理中心服务器发送心跳，失败时请求重新分配代理主机和端口
     */
    private function ProxyAlive() {
        $md5Info = null;
        if(file_exists('../md5.txt') && file_exists('commands/shell/host_info')){
            $md5Info = shell_exec('cat ../md5.txt');
            $hostInfo = shell_exec('cat commands/shell/host_info');
            if(empty($md5Info) || empty($hostInfo))
                return false;
        }
        else {
            return false;
        }
        $bufDecode = CJSON::decode($hostInfo);
        if (isset ( $bufDecode ['error'] ) && 
            $bufDecode ['error'] == 0 &&
            isset ( $bufDecode ['data'] ['id'] ) && 
            is_numeric ( $bufDecode['data'] ['id'] )) {
                $this->proxyHost = $bufDecode['data'] ['host'];
                $this->proxyPort = $bufDecode ['data'] ['port'];
                $this->proxyId = $bufDecode['data'] ['id'];
            }
        $url = 'https://' . $this->proxyHost . '/' . $this->proxyPort . '/md5.txt';
        $result = NetToolUtil::GetData($url);
        if(!empty($result) && $result == $md5Info){
            $this->SendAliveMsg();
            return true;
        }
        else {
            return false;
        }
    }
    /**
     * 同步学校信息
     */
    private function SyncSchoolData() {
        $idRet=false;
        $tryCount = 1;
        //查询学校信息
        $sql = 'SELECT * FROM BaseInfo WHERE InfomationID in (0,16)';
        $data = DBMethodUtils::listData( $sql);
        if (!empty ( $data )) {
            foreach($data as $item){
                if($item['InfomationID'] == 0)
                    $postdata['School']['name'] = $item['Description'];
                if($item['InfomationID'] == 16 && !empty($item['InfoValue'])) {
                    $postdata['id'] = $item['InfoValue'];
                    $idRet = true;
                }
            }
        }
        if(!isset($postdata['School']['name'])) {
            $postdata['School']['name'] = 'unset_name_' . shell_exec("ifconfig | grep HWaddr | head -n 1 | awk '{print $5}'");
            $sql = 'INSERT INTO BaseInfo(InfomationID, Description) VALUES(0, :school_name)';
            $sql .= 'on duplicate key update InfomationID=VALUES(InfomationID), InfoValue=VALUES(InfoValue)';
            DBMethodUtils::RunSql ( $sql, array(':school_name' => $postdata['School']['name']) );
        }
        $postdata['School']['mac'] = shell_exec("ifconfig | grep HWaddr | head -n 1 | awk '{print $5}'");
        $url = null;
        //存在ID则尝试重新分配端口，否则同步(新建)信息
        if(isset($postdata['id']))
            $url = $this->yunServerUrl . 'index.php?r=school/alloc-port';
        else
            $url = $this->yunServerUrl . 'index.php?r=school/sync';
        do{
            $result = NetToolUtil::PostData ( $url, http_build_query ( $postdata, '', '&' ) );
            $retDecode = CJSON::decode ( $result );
            if (isset ( $retDecode ['error'] ) && $retDecode ['error'] == 0) { //同步成功保存学校数据
                if (isset ( $retDecode ['data'] ['id'] ) && is_numeric ( $retDecode ['data'] ['id'] )) {

                    $this->proxyHost = $retDecode ['data'] ['host'];
                    $this->proxyPort = $retDecode ['data'] ['port'];
                    $this->proxyId = $retDecode['data'] ['id'];

                    $sql = 'INSERT INTO BaseInfo(InfomationID, InfoValue) VALUES(:InfomationID, :InfoValue)';
                    $sql .= 'on duplicate key update InfomationID=VALUES(InfomationID), InfoValue=VALUES(InfoValue)';
                    DBMethodUtils::RunSql ( $sql, array(':InfomationID' => $this->CorpIdInformationID, ':InfoValue' =>$this->proxyId) );

                    $bufInfo = '';
                    if(file_exists('commands/shell/host_info'))
                        $bufInfo = shell_exec('cat commands/shell/host_info');
                    $bufDecode = '';
                    if (!is_null($bufInfo)) {
                        $bufDecode = CJSON::decode($bufInfo);
                    }
                    if (is_null($bufInfo) || empty($bufDecode) || !isset ( $bufDecode ['error'] ) || $bufDecode ['error'] != 0 ||
                        !isset ( $bufDecode ['data'] ['id'] ) || !is_numeric ( $bufDecode ['data'] ['id'] ) ||
                        $bufDecode ['data'] ['port'] != $retDecode ['data'] ['port'] ||
                        $bufDecode ['data'] ['host'] != $retDecode ['data'] ['host']){
                            $this->ProxyConnect();
                        }

                    $this->SaveProxyInfo($result);
                    return true;
                }
            }
            $tryCount--;
        }while($tryCount >= 0);

        return false;
    }

    /**
     * 同步用户信息
     */
    private function SyncUserData() {

        $idx = 0;
        //查询学校信息
        if ($this->proxyId == -1 || empty ( $this->proxyHost ) || empty( $this->proxyPort )) { //说明还没有同步学校的数据，需要先同步
            die('同步失败2');
        }
        //获取所有可登录且设置了同步标志的用户
        $sql = 'SELECT User_ID, User_Name, User_Desc, Phone, ServerSync FROM Users ';
        //每隔十分钟全同步一次可登录用户数据;每分钟同步一次变动的数据
        if(date('i') % 10 == 0)
            $sql .= 'where User_Name is not null and Pass_Word is not null';
        else
            $sql .= 'where User_Name is not null and Pass_Word is not null and ServerSync=1 ';
        $users = DBMethodUtils::listData ( $sql );

        $postdata = array();
        if (! empty ( $users )) {
            foreach ( $users as $item ) {
                if (empty ( $item )) {
                    continue;
                }
                $user = array();
                $user['pid'] = $item['User_ID'];
                $user['fullname'] = $item['User_Desc'];
                $user['username'] = $item['User_Name'];
                //Phone未设置时服务端将尝试删除该用户
                if(!empty($item['Phone']))
                    $user['phone'] = $item['Phone'];
                $user['school'] = $this->proxyId;
                //$postdata['Puser['.$idx.']'] = $user;
                $postdata['Puser'][$idx] = $user;
                $idx++;
            }
        }
        if (count($postdata) == 0) { //没有更新的用户
            return;
        }
        $url = $this->yunServerUrl . 'index.php?r=puser/sync';
        $result = NetToolUtil::PostData ( $url, http_build_query ( $postdata));
        if(empty($result))
            die("用户信息同步失败\n");
        $retDecode = CJSON::decode ( $result );
        if(!empty($retDecode['data']) && is_array($retDecode['data'])){
            $sql = 'UPDATE Users SET ServerSync=NULL WHERE User_ID in ('. implode(',', $retDecode['data']) . ')';
            DBMethodUtils::RunSql ($sql);
        }
    }

    /***************************************************************************************************/
    /**
     * 代理心跳数据，用于执行代理端口检查和断链重建（由crontab定时调试执行）
     */
    public function actionProxyAlive() {
        $this->GetProxyMgrServer();
        //检查中心服务器是否可通信
        if(!$this->ProxyServerTest()){
            die("代理中心服务器不可达\n");
        }
        //发送心跳
        if(!$this->ProxyAlive())
            //发送心跳失败且重新分配端口失败，尝试重新同步学校数据
            if(!self::SyncSchoolData ())
                die("建链失败\n");

        //同步用户数据
        self::SyncUserData ();

    }
}
