<?php

// uncomment the following to define a path alias
// Yii::setPathOfAlias('local','path/to/local-folder');

// This is the main Web application configuration. Any writable
// CWebApplication properties can be configured here.
return array(
	'basePath'=>dirname(__FILE__).DIRECTORY_SEPARATOR.'..',
	'name'=>'智能设备',
	'timeZone'=>'Asia/Chongqing',
	// preloading 'log' component
	'preload'=>array('log'),
	'language' => 'zh_cn',

	// autoloading model and component classes
	'import'=>require(dirname(__FILE__).'/import.php'),

	'modules'=>array(
		// uncomment the following to enable the Gii tool
		'gii'=>array(
			'class'=>'system.gii.GiiModule',
			'password'=>'giiroot',
			// If removed, Gii defaults to localhost only. Edit carefully to taste.
			'ipFilters'=>array('127.0.0.1','::1'),
		),
        'admin',
	),
	// application components
	'components'=>array(

		'user'=>array(
			// enable cookie-based authentication
			'allowAutoLogin'=>false,
		),
		//国际化
        'i18n' => require(__DIR__ . '/i18n.php'),
		'yexcel' => array(
   			'class' =>'ext.yexcel.Yexcel'
		),
		// uncomment the following to enable URLs in path-format
		'urlManager'=>array(
			'urlFormat'=>'path',
			'rules'=>array(
				'<controller:\w+>/<id:\d+>'=>'<controller>/view',
				'<controller:\w+>/<action:\w+>/<id:\d+>'=>'<controller>/<action>',
				'<controller:\w+>/<action:\w+>'=>'<controller>/<action>',
			),
		),		
		// database settings are configured in database.php
		'db'=>require(dirname(__FILE__).'/database.php'),			//数据库配置
		'cache'=>require(dirname(__FILE__).'/cache.php'),			//文件缓存
		'errorHandler'=>array(
			// use 'site/error' action to display errors
			'errorAction'=>'site/error',
		),
		'log'=>require(dirname(__FILE__).'/log.php'),

	),

	'params'=> require(__DIR__ . '/params.php')
);
