<?php
/**
 * BW801相关的APP的API 
 *
 */
class BWPlayerController extends ServerController {
	
	//	private $PlayerbrdgrpsetName = array ("分区一", "分区二", "分区三", "分区四", "分区五", "分区六", "分区七", "分区八", "分区九", "分区十" );
	private $PlayerbrdgrpsetStatus = array (1, 2, 4, 8, 16, 32, 64, 128, 256, 512 );
	
	/**
	 * 获取BW801设备列表
	 */
	public function actionList() {
		
		$dataParam = $this->LoadDataParam ();
		
		if ($dataParam == null) {
			echo $this->PackResponseDataParamErr ();
			return;
		}
		//起始位置
		$start = $this->GetDataParam ( $dataParam, "start", 0, true );
		//获取条数
		$size = $this->GetDataParam ( $dataParam, "size", 200, true );
		
//		$Sql = "SELECT a.PlayerID, IF(LENGTH(a.PlayerName) > 0, a.PlayerName, a.PlayerID) AS PlayerName, IF(LENGTH(b.PlayerID) > 0, 1, 0) AS Online, 
//			IF(LENGTH(c.PlayerID) > 0, 1, 0) AS Playing 
//			FROM Players a 
//			LEFT JOIN PlayerStatus b ON a.PlayerID = b.PlayerID 
//			LEFT JOIN PlayerAlive c ON a.PlayerID=c.PlayerID
//			WHERE PlayerType = 1 ORDER BY b.PlayerID DESC, a.PlayerID LIMIT " . $start . "," . $size;
//		
		
		$Sql = 'SELECT * FROM (SELECT  
				a.PlayerID, a.SessionName AS PlayerName, IF(LENGTH(c.PlayerID) > 0, 1, 0) AS Online, 
				IF(LENGTH(b.PlayerID) > 0, 1, 0) AS Playing
				FROM PlaySessions a 
				LEFT JOIN PlayingSessions b on  b.SessionID = a.SessionID 
				LEFT JOIN PlayerStatus c on c.PlayerID = a.PlayerID 
				LEFT JOIN Players d on d.PlayerID = a.PlayerID 
				LEFT JOIN PlayerAlive e ON a.PlayerID=e.PlayerID
				WHERE (a.Parent is null or (Parent = 0)) and (a.SessionType = 1 OR a.SessionType = 10)) aa LIMIT ' . $start . ',' . $size;
		
		
		$Res = DBMethodUtils::listData ( $Sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Res );
	}
	
	/**
	 * 获取设备信息
	 */
	public function actionInfo() {
		
		/**
		 * 1、当前曲目库名字
		 * 2、当前播放列表
		 * 3、线路1、2状态
		 * 4、麦克风输入状态
		 * 5、播放状态
		 * 6、当前播放文件
		 * 7、播放进度
		 */
		$dataParam = $this->LoadDataParam ();
		
		if ($dataParam == null) {
			echo $this->PackResponseDataParamErr ();
			return;
		}
		//设备编号
		$playerID = $this->GetDataParam ( $dataParam, "playerID", null );
		
		//判断设备是否在线
//		$sql = "SELECT a.PlayerID,  IF(LENGTH(a.PlayerName) > 0, a.PlayerName, a.PlayerID) AS PlayerName, a.PlayerType, b.SessionID, b.ScheduleID, b.IpAddress, b.NetID, b.ActualSesID, b.PlayPort, b.PlayType
//		 	FROM Players a LEFT JOIN PlayerStatus b ON a.PlayerID = b.PlayerID
//			WHERE a.PlayerID = '" . $playerID . "'";
		
		$sql = 'SELECT * FROM (SELECT  
				a.PlayerID, a.SessionName AS PlayerName, IF(LENGTH(c.PlayerID) > 0, 1, 0) AS Online, 
				IF(LENGTH(e.PlayerID) > 0, 1, 0) AS Playing, c.IpAddress
				FROM PlaySessions a 
				LEFT JOIN PlayingSessions b on  b.SessionID = a.SessionID 
				LEFT JOIN PlayerStatus c on c.PlayerID = a.PlayerID 
				LEFT JOIN Players d on d.PlayerID = a.PlayerID 
				LEFT JOIN PlayerAlive e ON a.PlayerID=e.PlayerID
				WHERE (a.Parent is null or (Parent = 0)) and (a.SessionType = 1 OR a.SessionType = 10)) aa WHERE PlayerID = "' . $playerID . '"';
		
		$Player = DBMethodUtils::findData ( $sql );
		
		if (empty ( $Player ) || empty ( $Player ['IpAddress'] )) { //设备不在线
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_NO_EXIST_OFFLINE, "设备无效或不在线", null );
			return;
		}
		$PlayerIp = $Player ['IpAddress'];
		//获取播放状态
		$Data = BWPlayerManager::loadPlayerCurrentStatus ( $PlayerIp );
		
		if (empty ( $Data )) { //说明获取数据失败
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_NO_EXIST_OFFLINE, "设备无效或不在线 ", null );
			return;
		}
		$CurDirID = $this->GetDataParam ( $Data, "CurDirID", "" ); //当前目录ID 或者0xFF（表示当前BW801没有可识别的目录）
		$CurDirName = $this->GetDataParam ( $Data, "CurDirName", "" ); //当前目录名称 
		$CurFileId = $this->GetDataParam ( $Data, "CurFileId", "" ); //当前目录下文件的ID号 或者0xFF（表示当前BW801本地目录下没有可识别的MP3文件）
		$FileName = $this->GetDataParam ( $Data, "FileName", "" ); //MP3歌曲
		$brdState = $this->GetDataParam ( $Data, "brdState", "" ); //当前BW801是否处于广播状态，0：未广播，1：广播
		$BrdGrpMember = $this->GetDataParam ( $Data, "BrdGrpMember", "" ); //当前选定的广播分区，该值为一个16bit的值，低10位的每一个bit表示一个分区是否已经选上，高6个bit置0，低10个比特含义，bit为0表示未勾选分区，比特为1表示分区已选。
		$inputLine1 = $this->GetDataParam ( $Data, "inputLine1", "" ); // 0 表示未打开线路输入1，1表示打开线路1
		$inputLine2 = $this->GetDataParam ( $Data, "inputLine2", "" ); // 0 表示未打开线路输入1，1表示打开线路1
		$inputMic = $this->GetDataParam ( $Data, "inputMic", "" ); // 0 表示未打开线路输入1，1表示打开线路1
		$Mp3PlayState = $this->GetDataParam ( $Data, "Mp3PlayState", "" ); //bw801本地MP3文件是否处于播放状态，0表示未播放，1表示正在播放。
		$playTime = $this->GetDataParam ( $Data, "playTime", "" ); //32bit值的MP3当前播放时间。
		

		$Out = array ();
		$Out ['PlayerID'] = $Player ['PlayerID'];
		$Out ['PlayerName'] = $Player ['PlayerName'];
		$Out ['CurDirID'] = $CurDirID;
		$Out ['CurDirName'] = $CurDirName;
		$Out ['CurFileId'] = $CurFileId;
		$Out ['CurFileName'] = $FileName;
		$Out ['BrdState'] = $brdState;
		$Out ['BrdGrpMember'] = $BrdGrpMember;
		$Out ['InputLine1'] = $inputLine1;
		$Out ['InputLine2'] = $inputLine2;
		$Out ['inputMic'] = $inputMic;
		$Out ['Mp3PlayState'] = $Mp3PlayState;
		$Out ['PlayTime'] = $playTime;
		$Out ['MusicList'] = array ();
		
		//需要获取播放列表
		if (! empty ( $CurDirID )) {
			//获取播放目录信息
			$MusicDir = BWPlayerManager::listPlayerMusic ( $PlayerIp );
			
			if (! empty ( $MusicDir )) {
				foreach ( $MusicDir as $item ) {
					if (empty ( $item ['DirID'] )) {
						continue;
					}
					if ($item ['DirID'] == $CurDirID) {
						if (isset ( $item ['MP3file'] ) && count ( $item ['MP3file'] ) > 0) {
							foreach ( $item ['MP3file'] as $item ) {
								if (empty ( $item )) {
									continue;
								}
								$Out ['MusicList'] [] = $item;
							}
						}
						break;
					}
				}
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Out );
	
	}
	
	/**
	 * 获取播放目录
	 */
	public function actionListMusicDir() {
		
		$dataParam = $this->LoadDataParam ();
		
		if ($dataParam == null) {
			echo $this->PackResponseDataParamErr ();
			return;
		}
		//设备编号
		$playerID = $this->GetDataParam ( $dataParam, "playerID", null );
		
		//判断设备是否在线
		$sql = "SELECT a.PlayerID,  a.PlayerName, a.PlayerType, b.SessionID, b.ScheduleID, b.IpAddress, b.NetID, b.ActualSesID, b.PlayPort, b.PlayType
		 	FROM Players a LEFT JOIN PlayerStatus b ON a.PlayerID = b.PlayerID
			WHERE a.PlayerID = '" . $playerID . "'";
		$Player = DBMethodUtils::findData ( $sql );
		
		if (empty ( $Player ) || empty ( $Player ['IpAddress'] )) { //设备不在线
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_NO_EXIST_OFFLINE, "设备无效或不在线", null );
			return;
		}
		$PlayerIp = $Player ['IpAddress'];
		
		$Out = array ();
		//获取播放目录信息
		$MusicDir = BWPlayerManager::listPlayerMusic ( $PlayerIp );
		
		if (! empty ( $MusicDir )) {
			foreach ( $MusicDir as $item ) {
				if (empty ( $item ) || empty ( $item ['DirID'] )) {
					continue;
				}
				$TemoMp3Files = array ();
				
				if (! empty ( $item ['MP3file'] )) {
					foreach ( $item ['MP3file'] as $file ) {
						if (empty ( $file )) {
							continue;
						}
						$TemoMp3Files [] = $file;
					}
				}
				$item ['MP3file'] = $TemoMp3Files;
				$Out [] = $item;
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Out );
	}
	
	/**
	 * 获取分区设置 
	 */
	public function actionListPlayerbrdgrpset() {
		
		$dataParam = $this->LoadDataParam ();
		
		if ($dataParam == null) {
			echo $this->PackResponseDataParamErr ();
			return;
		}
		//设备编号
		$playerID = $this->GetDataParam ( $dataParam, "playerID", null );
		
		//判断设备是否在线
		$sql = "SELECT a.PlayerID, a.PlayerName, a.PlayerType, b.SessionID, b.ScheduleID, b.IpAddress, b.NetID, b.ActualSesID, b.PlayPort, b.PlayType
		 	FROM Players a LEFT JOIN PlayerStatus b ON a.PlayerID = b.PlayerID
			WHERE a.PlayerID = '" . $playerID . "'";
		$Player = DBMethodUtils::findData ( $sql );
		
		if (empty ( $Player ) || empty ( $Player ['IpAddress'] )) { //设备不在线
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_NO_EXIST_OFFLINE, "设备无效或不在线", null );
			return;
		}
		$PlayerIp = $Player ['IpAddress'];
		
		//获取播放状态
		$Data = BWPlayerManager::loadPlayerCurrentStatus ( $PlayerIp );
		
		if (empty ( $Data )) { //说明获取数据失败
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_NO_EXIST_OFFLINE, "设备无效或不在线", null );
			return;
		}
		$BrdGrpMember = $this->GetDataParam ( $Data, "BrdGrpMember", "" ); //当前选定的广播分区，该值为一个16bit的值，低10位的每一个bit表示一个分区是否已经选上，高6个bit置0，低10个比特含义，bit为0表示未勾选分区，比特为1表示分区已选。
		

		//获取分区名字
		$sql = 'SELECT a.Index, b.Name FROM PlayerKeys a LEFT JOIN DevClasses b ON a.GroupID = b.ClassID WHERE a.PlayerID = "' . $playerID . '"';
		$PlayerName = DBMethodUtils::listData ( $sql );
		$PlayerNameArr = array ();
		
		if (! empty ( $PlayerName )) {
			foreach ( $PlayerName as $item ) {
				$PlayerNameArr [$item ['Index']] = $item ['Name'];
			}
		}
		$Out = array ();
		
		for($i = 0; $i < 10; $i ++) {
			$Status = ((( int ) ($BrdGrpMember)) & $this->PlayerbrdgrpsetStatus [$i]) > 0 ? 1 : 0;
			$Out [] = array ("BrdgrpId" => $i, "Name" => isset ( $PlayerNameArr [$i + 1] ) ? $PlayerNameArr [$i + 1] : '', "Status" => $Status );
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Out );
	}
	
	/**
	 * 分区设置
	 */
	public function actionPlayerbrdgrpset() {
		
		//{"playerID":"设备ID","playerbrdfrp":[{"id":"1","status":"0"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"}]}
		

		$dataParam = $this->LoadDataParam ();
		
		if ($dataParam == null) {
			echo $this->PackResponseDataParamErr ();
			return;
		}
		//设备编号
		$playerID = $this->GetDataParam ( $dataParam, "playerID", null );
		//分区选择情况,格式：[{"id":"1","status":"0"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"},{"id":"1","status":"1"}]
		$playerbrdfrp = $this->GetDataParam ( $dataParam, "playerbrdfrp", null );
		
		//判断设备是否在线
		$sql = "SELECT a.PlayerID,  a.PlayerName, a.PlayerType, b.SessionID, b.ScheduleID, b.IpAddress, b.NetID, b.ActualSesID, b.PlayPort, b.PlayType
		 	FROM Players a LEFT JOIN PlayerStatus b ON a.PlayerID = b.PlayerID
			WHERE a.PlayerID = '" . $playerID . "'";
		$Player = DBMethodUtils::findData ( $sql );
		
		if (empty ( $Player ) || empty ( $Player ['IpAddress'] )) { //设备不在线
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_NO_EXIST_OFFLINE, "设备无效或不在线", null );
			return;
		}
		$PlayerIp = $Player ['IpAddress'];
		
		//分区数据原始状态
		$Param = array ();
		
		for($i = 0; $i < 16; $i ++) {
			$Param ["" . $i] = 0;
		}
		//获取播放状态
		$Data = BWPlayerManager::loadPlayerCurrentStatus ( $PlayerIp );
		
		if (! empty ( $Data )) { //说明获取数据失败
			$BrdGrpMember = $this->GetDataParam ( $Data, "BrdGrpMember", "" ); //当前选定的广播分区，该值为一个16bit的值，低10位的每一个bit表示一个分区是否已经选上，高6个bit置0，低10个比特含义，bit为0表示未勾选分区，比特为1表示分区已选。
			for($i = 0; $i < 10; $i ++) {
				$Param ["" . $i] = (( int ) ($BrdGrpMember)) & $this->PlayerbrdgrpsetStatus [$i];
			}
		}
		if (! empty ( $playerbrdfrp ) && count ( $playerbrdfrp ) > 0) {
			foreach ( $playerbrdfrp as $item ) {
				if (isset ( $Param [$item ['id']] ) && in_array ( $item ['status'], array ("0", "1" ) )) {
					$Param [$item ['id']] = ( int ) $item ['status'];
				}
			}
		}
		//分区数据
		$brdGrpCtrl = 0;
		
		for($i = 15; $i >= 0; $i --) {
			if (isset ( $this->PlayerbrdgrpsetStatus [$i] )) {
				$brdGrpCtrl += $Param ["" . $i] * $this->PlayerbrdgrpsetStatus [$i];
			}
		}
		$res = BWPlayerManager::Playerbrdgrpset ( $PlayerIp, $brdGrpCtrl );
		
		if (! empty ( $res ) && "success" == strtolower ( str_replace ( "\"", "", $res ) )) {
			//修改成功
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", null );
			return;
		}
		
		//修改失败
		echo $this->PackResponseData ( ErrcodeUtil::$FAILED, "操作失败", null );
	}
	
	/**
	 * 设备控制
	 */
	public function actionPlayerCtrl() {
		
		$dataParam = $this->LoadDataParam ();
		
		if ($dataParam == null) {
			echo $this->PackResponseDataParamErr ();
			return;
		}
		//设备编号
		$playerID = $this->GetDataParam ( $dataParam, "playerID", "" );
		$brdCtrl = $this->GetDataParam ( $dataParam, "brdCtrl", "" ); //是否打开广播，0：关闭，1：打开（不传为不修改）
		$line1Input = $this->GetDataParam ( $dataParam, "line1Input", "" ); //是否打开线路1输入，0：关闭，1：打开（不传为不修改）
		$line2Input = $this->GetDataParam ( $dataParam, "line2Input", "" ); //是否打开线路2输入，0：关闭，1：打开（不传为不修改）
		$micInput = $this->GetDataParam ( $dataParam, "micInput", "" ); //是否打开麦克风输入，0：关闭，1：打开（不传为不修改）
		$mp3PlayCtrl = $this->GetDataParam ( $dataParam, "mp3PlayCtrl", "" ); //是否播放MP3文件，0：停止，1：播放（不传为不修改）, 2：暂停 （不传为不修改）
		$mp3FileChange = $this->GetDataParam ( $dataParam, "mp3FileChange", "" ); //0:当前文件，1：上一首，2：下一首，3：指定MP3文件（不传为不修改）
		$dirId = $this->GetDataParam ( $dataParam, "dirId", "" ); //指定MP3文件所在的目录号，当Mp3FileChange 为3时，这1参数为必传参数
		$fileId = $this->GetDataParam ( $dataParam, "fileId", "" ); //指定MP3文件所在目录的文件ID号，当Mp3FileChange 为3时，这1参数为必传参数
		

		//判断设备是否在线
		$sql = "SELECT a.PlayerID,  a.PlayerName, a.PlayerType, b.SessionID, b.ScheduleID, b.IpAddress, b.NetID, b.ActualSesID, b.PlayPort, b.PlayType
		 	FROM Players a LEFT JOIN PlayerStatus b ON a.PlayerID = b.PlayerID
			WHERE a.PlayerID = '" . $playerID . "'";
		$Player = DBMethodUtils::findData ( $sql );
		
		if (empty ( $Player ) || empty ( $Player ['IpAddress'] )) { //设备不在线
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_NO_EXIST_OFFLINE, "设备无效或不在线", null );
			return;
		}
		$PlayerIp = $Player ['IpAddress'];
		
		$res = BWPlayerManager::PlayerCtrlSet ( $PlayerIp, $brdCtrl, $line1Input, $line2Input, $micInput, $mp3PlayCtrl, $mp3FileChange, $dirId, $fileId );
		
		if (! empty ( $res ) && "success" == strtolower ( str_replace ( "\"", "", $res ) )) {
			//修改成功
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", null );
			return;
		}
		
		//修改失败
		echo $this->PackResponseData ( ErrcodeUtil::$FAILED, "操作失败", null );
	}
}
