<?php
/*************************************************
 * 模块描述：
 * 定义任务管理模块的功能
 ************************************************/
class TaskController extends ServerController {
	
	//定时任务排序字段映射关系
	public $SessionSortNameArr = array ('sessionname' => 'SessionName', //任务名字
'priority' => 'Priority', //优先级
'playtime' => 'PlayTime', //执行时间
'sysenabled' => 'SysEnabled', //设备控制
'rfdevctrl' => 'RfDevCtrl', //扩展设备状态
'circlelength' => 'CircleLength' ); //播出时长
	

	//模板排序字段映射
	public $TemplateSortNameArr = array ('templatename' => 'TemplateName' ); //模板名字
	

	//模板排序字段映射
	public $ModeSortNameArr = array ('modename' => 'ModeName', //模式名字
'priority' => 'Priority' ); //优先级
	

	/*************************************************************************/
	/**
	 * 加载任务树
	 */
	public function actionListTaskTree() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		$tree = array ();
		
		//定时任务，成员列表
		$sql = "SELECT User_ID as id, User_Name as text, 0 as Parent FROM Users WHERE User_ID > 0;";
		
		if ($UserID > 0) {
			$sql = "SELECT User_ID as id, User_Name as text, 0 as Parent FROM Users WHERE User_ID = '" . $UserID . "';";
		}
		$timeTaskUser = DBMethodUtils::listData ( $sql );
		$timeTask = TaskUtil::PackTaskTreeParent ( 0, $this->getStr ( 'appcommon', 'session_time' ), 'Task/ListTimeTasks', $timeTaskUser );
		$tree [0] = $timeTask;
		//		//任务模板
		//		$template = array ();
		//		try {
		//			$sql = "SELECT idTaskTemplate as id, IF (idTaskTemplate=0, '" . $this->getStr ( 'appcommon', 'default' ) . "', TemplateName) AS text, 1 as Parent, Enabled FROM TaskTemplate";
		//			$template = DBMethodUtils::listData ( $sql );
		//		} catch ( Exception $e ) {
		//
		//		}
		//		$tree [1] = TaskUtil::PackTaskTreeParent ( 1, $this->getStr ( 'appcommon', 'session_template' ), 'Task/ListTimeTasks', $template );
		//		//运行模式
		//		$tree [2] = TaskUtil::PackTaskTreeParent ( 2, $this->getStr ( 'appcommon', 'session_runingmode' ), 'Task/ListRuningModes', TaskUtil::LoadBrodcastModes ( 1, 1 ) );
		//		//备用模式
		//		$tree [3] = TaskUtil::PackTaskTreeParent ( 3, $this->getStr ( 'appcommon', 'session_reservemode' ), 'Task/ListReserveModes', TaskUtil::LoadBrodcastModes ( 0, 2 ) );
		//		//手动广播
		//		$tree [4] = TaskUtil::PackTaskTreeParent ( 4, $this->getStr ( 'appcommon', 'session_manual' ), 'Task/ListManualTasks', null );
		//		//实时采播
		//		$tree [5] = TaskUtil::PackTaskTreeParent ( 5, $this->getStr ( 'appcommon', 'session_realtimemining' ), 'Task/ListRealTimeMining', null );
		

		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $tree );
	}
	
	/**
	 * 加载任务数据
	 */
	public function actionLoadPlaySession() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (! isset ( $DataParam ['SessionID'] ) || ! is_numeric ( $DataParam ['SessionID'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sessionID = $DataParam ['SessionID'];
		
		//获取任务基本信息
		$sql = "SELECT * FROM PlaySessions WHERE SessionID=" . $sessionID;
		
		if ($UserID > 0) {
			$sql .= ' AND Owner="' . $UserID . '"';
		}
		$PlaySession = DBMethodUtils::findData ( $sql );
		
		if (is_null ( $PlaySession )) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '任务不存在！', null );
			return;
		}
		$taskInfo = array ();
		
		//任务基本信息
		$baseInfo = array ();
		//任务id
		$baseInfo ['SessionID'] = $PlaySession ['SessionID'];
		//任务名称
		$baseInfo ['SessionName'] = $PlaySession ['SessionName'];
		//任务类型,0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
		$baseInfo ['SessionType'] = $PlaySession ['SessionType'];
		//优先级
		$baseInfo ['Priority'] = $PlaySession ['Priority'];
		
		//强制接收标识(StreamType高4为来判断，最高位：1：强制，0：不强制)
		$baseInfo ['SteamTypeUp'] = round ( $PlaySession ['StreamType'] / 128 );
		//00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
		$baseInfo ['SteamTypeDown'] = $PlaySession ['StreamType'] - round ( $PlaySession ['StreamType'] / 128 ) * 128;
		//所属用户id
		$baseInfo ['Owner'] = $PlaySession ['Owner'];
		$taskInfo ['BaseInfo'] = $baseInfo;
		
		if (! is_null ( $PlaySession ['BrdMode'] ) && $PlaySession ['BrdMode'] > 0) {
			//模式
			$mode = array ();
			$mode ['BrdMode'] = $PlaySession ['BrdMode']; //是否广播模式任务，>0广播模式ID 是模式任务，null表示非模式任务
			$mode ['MemmberMode'] = $PlaySession ['MemberMode']; //默认为0,是否使用模式成员，1使用模式成员，0不使用
			$taskInfo ['Mode'] = $mode;
		}
		
		if ($baseInfo ['SteamTypeDown'] == 1 || $baseInfo ['SteamTypeDown'] == 2 || $baseInfo ['SteamTypeDown'] == 3) {
			//广播任务
			$Brodcast = array ();
			//音量调节
			$Brodcast ['AudioGain'] = $PlaySession ['AudioGain'];
			//播放时间，秒
			$Brodcast ['CircleLength'] = $PlaySession ['CircleLength'];
			//播放模式,媒体播放方式，0顺序播放，1随机播放，默认是0，广播任务才用
			$Brodcast ['PlayMode'] = $PlaySession ['PlayMode'];
			//播放列表
			$sql = "SELECT a.FileID, a.SequenceID, b.FileName, b.TotalTime FROM PlayListFiles a LEFT JOIN
				MediaFiles b ON a.FileID=b.MediaID WHERE SessionID='" . $sessionID . "' ORDER BY SequenceID";
			$Brodcast ['PlayFileList'] = DBMethodUtils::listData ( $sql );
			
			$taskInfo ['Brodcast'] = $Brodcast;
		} else if ($baseInfo ['SteamTypeDown'] == 0) {
			//控制任务
			$DeviceCtrl = array ();
			//设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制
			$DeviceCtrl ['SysEnabled'] = $PlaySession ['SysEnabled'];
			
			//扩展设备信息
			$expandSource = ExpandUtil::LoadExpandDev ();
			//扩展设备模式
			$expandMode = ExpandUtil::LoadExpandMode ();
			
			//扩展电源
			$DeviceCtrl ['RfDevCtrl'] = DeviceUtil::DepackRfDevCtrl ( $expandSource, $PlaySession ['RfDevCtrl'], $expandMode );
			//
			//			if (! is_null ( $DeviceCtrl ['SysEnabled'] ) && ! is_null ( $PlaySession ['RfDevCtrl'] )) {
			//
			//
			//				$DeviceCtrl ['RfDevCtrl'] =
			//			}
			$taskInfo ['DeviceCtrl'] = $DeviceCtrl;
		}
		
		//接收成员
		$taskInfo ['SessionDevice'] = TaskUtil::LoadSessionDevice ( $sessionID, $UserID );
		
		//执行时间
		$sql = "SELECT a.ScheduleID, WeekDay, DATE_FORMAT(PlayTime,'%H:%i:%S') as PlayTime, TempFlag, Pause FROM PlaySessionTime a
			LEFT JOIN PlayingSessions b ON a.SessionID=b.SessionID AND a.ScheduleID=b.ScheduleID WHERE a.SessionID='" . $sessionID . "'";
		$taskInfo ['PlayTime'] = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $taskInfo );
	}
	
	/**
	 * 获取播放列表
	 */
	public function actionListPlayList() {
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (! isset ( $DataParam ['SessionID'] ) || ! is_numeric ( $DataParam ['SessionID'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sessionID = $DataParam ['SessionID'];
		
		//播放列表
		$sql = "SELECT a.FileID, a.SequenceID, b.FileName, b.TotalTime FROM PlayListFiles a LEFT JOIN
				MediaFiles b ON a.FileID=b.MediaID WHERE SessionID='" . $sessionID . "' ORDER BY SequenceID";
		$playList = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $playList );
	}
	
	/**
	 * 获取任务接收成员
	 */
	public function actionListSessionDevices() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sessionID = - 1;
		
		if (isset ( $DataParam ['SessionID'] ) && is_numeric ( $DataParam ['SessionID'] )) {
			$sessionID = $DataParam ['SessionID'];
		}
		$sessionDevices = TaskUtil::LoadSessionDevice ( $sessionID, $UserID );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $sessionDevices );
	}
	
	/**
	 * 编辑任务
	 */
	public function actionEditSession() {
		$UserId = $this->GetPostOwnerID ();
		$res = TaskUtil::EditSessions ( $UserId );
		
		echo $this->PackResponseDataAll ( $res );
	}
	
	/**
	 * 编辑任务
	 */
	public function actionEditSessionForApp() {
		
		ToolUtil::writeLog ( CJSON::encode ( $_POST ) );
		
		$UserId = $this->GetPostOwnerID ();
		$res = TaskUtil::EditSessions ( $UserId, true );
		
		echo $this->PackResponseDataAll ( $res );
	}
	
	/**
	 * 删除任务
	 */
	public function actionDeleteSessions() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$SessionArr = array ();
		
		foreach ( $DataParam as $item ) {
			$SessionId = $item ['SessionID'];
			$ScheduleID = $item ['ScheduleID'];
			
			$SessionArr [] = $SessionId;
			
			if (is_numeric ( $ScheduleID ) && $ScheduleID > 0) {
				//删除数据
				$sql = "call delete_task('" . $ScheduleID . "')";
				DBMethodUtils::RunSql ( $sql );
			} elseif (ScheduleID == '') {
				//删除整个任务
				TaskUtil::DeleteSessionByIDs ( $SessionId );
			}
		}
		//获取任务没有执行时间的
		$SessionArr = array_unique ( $SessionArr );
		
		if (! empty ( $SessionArr )) {
			$sql = 'SELECT a.* FROM PlaySessions a LEFT JOIN (SELECT COUNT(*) PalyeTimeCount, SessionID FROM PlaySessionTime GROUP BY SessionID) b ON a.SessionID=b.SessionID
			WHERE a.SessionID IN(' . implode ( ',', $SessionArr ) . ') AND PalyeTimeCount <= 0';
			
			$Sessions = DBMethodUtils::listData ( $sql );
			$temparr = array ();
			
			foreach ( $Sessions as $item ) {
				$temparr [] = $item ['SessionID'];
			}
			if (! empty ( $temparr )) {
				//删除整个任务
				TaskUtil::DeleteSessionByIDs ( implode ( ',', $temparr ) );
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '删除任务成功', null );
	}
	
	/**
	 * 播放任务
	 */
	public function actionPlaySession() {
		/*
		 [
		 {
		 "SessionID":"任务ID",
		 "ScheduleID":"播出时间ID,不传或为空表示没有时间限制"
		 }
		 ]
		 */
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		
		//参数内容
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam ) || count ( $DataParam ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//0 :停止, 1:播放，2：暂停
		$status = 1;
		//控制任务
		TaskUtil::CtrSession ( $UserID, $DataParam, $status );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '播出任务成功', null );
	}
	
	/**
	 * 暂停任务
	 */
	public function actionPasueSession() {
		/*
		 [
		 {
		 "SessionID":"任务ID",
		 "ScheduleID":"播出时间ID,不传或为空表示没有时间限制"
		 }
		 ]
		 */
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		//参数内容
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam ) || count ( $DataParam ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//0 :停止, 1:播放，2：暂停
		$status = 2;
		//控制任务
		TaskUtil::CtrSession ( $UserID, $DataParam, $status );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '任务暂停成功', null );
	}
	
	/**
	 * 停止任务
	 */
	public function actionStopSession() {
		
		/*
		 [
		 {
		 "SessionID":"任务ID",
		 "ScheduleID":"播出时间ID,不传或为空表示没有时间限制"
		 }
		 ]
		 */
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		
		//参数内容
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam ) || count ( $DataParam ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//0 :停止, 1:播放，2：暂停
		$status = 0;
		//控制任务
		TaskUtil::CtrSession ( $UserID, $DataParam, $status );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '任务停止成功', null );
	}
	
	/**
	 * 临时停播/取消临时停播
	 */
	public function actionTemporary() {
		
		/*
		 /*
		 [
		 {
		 "SessionID":"任务ID",
		 "ScheduleID":"播出时间ID",
		 "TempFlag" : "0:取消临时停闭，2：临时停播"
		 }
		 ]
		 */
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		
		//参数内容
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam ) || count ( $DataParam ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		foreach ( $DataParam as $item ) {
			$TempFlag = $item ['TempFlag'];
			
			if ($TempFlag != 0 && $TempFlag != 2) {
				continue;
			}
			$sql = 'UPDATE PlaySessionTime SET TempFlag=' . $TempFlag . ' WHERE ScheduleID=' . $item ['ScheduleID'] . ' AND SessionID=' . $item ['SessionID'];
			DBMethodUtils::RunSql ( $sql );
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '成功', null );
	}
	
	/**
	 * 编辑时间表
	 */
	public function actionEditTimeTable() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		//播出时间表,格式：[{'ScheduleID':'任务ID','SessionID':'任务ID','PlayTime':'播出时间，时分秒','TempFlag':'状态，0：正常，1：插播，2：暂停'}]
		$DataParam = null;
		
		if (isset ( $_POST ['DataParam'] )) {
			$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		}
		if (is_null ( $DataParam ) || count ( $DataParam ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//参数正常可以开始编辑
		foreach ( $DataParam as $item ) {
			if (empty ( $item ['ScheduleID'] ) || empty ( $item ['SessionID'] ) || ! isset ( $item ['PlayTime'] ) || ! isset ( $item ['TempFlag'] )) {
				continue;
			}
			if (! ToolUtil::JudgeTimeFormat ( $item ['PlayTime'] ) || $item ['TempFlag'] < 0 || $item ['TempFlag'] > 2) {
				continue;
			}
			//更新数据
			$sql = 'UPDATE PlaySessionTime SET PlayTime="2012-03-03 ' . $item ['PlayTime'] . '", TempFlag="' . $item ['TempFlag'] . '" WHERE ScheduleID="' . $item ['ScheduleID'] . '"
				AND SessionID="' . $item ['SessionID'] . '"';
			DBMethodUtils::RunSql ( $sql );
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '编辑成功', null );
	}
	/////////////////////////////////////////////////////////
	// 定时任务
	/////////////////////////////////////////////////////////
	/**
	 * 获取定时任务列表
	 */
	public function actionListTimeTasks() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT a.SessionID, a.ScheduleID, DATE_FORMAT(a.PlayTime,'%H:%i:%S') as PlayTime, b.CircleLength, a.TempFlag,
			IF(" . (is_null ( $UserID ) ? 0 : $UserID) . " <= 0, IF((ISNULL(uu.User_Name) OR LENGTH(uu.User_Name) < 1), b.SessionName, CONCAT(uu.User_Name, ':',b.SessionName)), b.SessionName) SessionName
			, b.SessionType, b.Priority, b.StreamType, b.SysEnabled, b.RfDevCtrl, dd.Pause,mf.FileName, IF(ISNULL(pl.PlayListCount), 0, pl.PlayListCount) AS PlayListCount 
			FROM PlaySessionTime a LEFT JOIN PlaySessions b ON a.SessionID=b.SessionID 
			LEFT JOIN PlayingSessions dd ON a.SessionID=dd.SessionID AND a.ScheduleID=dd.ScheduleID LEFT JOIN PlayingSessions ps ON a.SessionID=ps.SessionID 
			LEFT JOIN MediaFiles mf ON ps.PlayingFileID=mf.MediaID LEFT JOIN Users uu ON b.Owner=uu.User_ID
			LEFT JOIN (SELECT COUNT(*) AS PlayListCount, SessionID FROM PlayListFiles GROUP BY SessionID) pl ON a.SessionID=pl.SessionID
			WHERE SessionType IN (0,8)";
		
		//任务类型筛选,0:控制任务，1：广播任务，2：都选，3：都不选
		if (isset ( $DataParam ['SelectStreamType'] ) && is_numeric ( $DataParam ['SelectStreamType'] )) {
			
			switch ($DataParam ['SelectStreamType']) {
				case 0 : //控制任务
					$sql = $sql . " AND b.StreamType&7 = 0";
					break;
				case 1 : //广播任务
					$sql = $sql . " AND b.StreamType&7 != 0";
					break;
				case 2 : //所有任务
					break;
				case 3 : //都不选
					$sql = $sql . " AND b.StreamType&7 = -1";
					break;
				default :
					break;
			}
		}
		$OwnerWhere = array ();
		
		if ($UserID > 0) { //非最高权限管理员
			$OwnerWhere [] = " b.Owner = '" . $UserID . "'";
		} else {
			//			$OwnerWhere [] =" IF(b.Owner > 0, 1, Template=(SELECT InfoValue FROM BaseInfo WHERE InfomationID=257))";
			$OwnerWhere [] = " (ISNULL(b.Owner) AND Template=(SELECT InfoValue FROM BaseInfo WHERE InfomationID=257))";
		}
		$Owner = - 1;
		
		if (isset ( $DataParam ['Owner'] ) && is_numeric ( $DataParam ['Owner'] )) { //按照任务所属人筛选
			$Owner = $DataParam ['Owner'];
		}
		
		//任务创建者的id
		if (! is_null ( $Owner ) && $Owner > 0) {
			$OwnerWhere [] = " b.Owner = '" . $UserID . "'";
		}
		if (! empty ( $OwnerWhere )) {
			$sql .= ' AND (' . implode ( ' OR ', $OwnerWhere ) . ')';
		}
		//按照星期筛选
		$byweekday = false;
		
		if (isset ( $DataParam ['WeekDay'] )) {
			$WeekDay = $DataParam ['WeekDay'];
			
			if (is_numeric ( $WeekDay )) {
				$sql = $sql . " AND WeekDay = '" . $WeekDay . "'";
				$byweekday = true;
			}
		}
		//		if (is_null ( $UserID )) { //TODO 需要考虑是否需要模板
		//			//按照模板筛选(定时任务不需要传递这个值)
		//			if (isset ( $DataParam ['Template'] ) && is_numeric ( $DataParam ['Template'] )) {
		//				$sql .= " AND Template='" . $DataParam ['Template'] . "'";
		//			} else {
		//				$sql .= " AND Template=(SELECT InfoValue FROM BaseInfo WHERE InfomationID=257)";
		//			}
		//		}
		

		//搜索关键字,按照名字搜索
		if (isset ( $DataParam ['SearchKey'] ) && "" != trim ( $DataParam ['SearchKey'] )) {
			$sql .= " AND SessionName like '%" . $DataParam ['SearchKey'] . "%'";
		}
		$sql = $sql . " GROUP BY a.SessionID,DATE_FORMAT(a.PlayTime,'%H:%i:%S')";
		
		//排序
		if (! empty ( $DataParam ['SortName'] ) && empty ( $DataParam ['SortOrder'] )) {
			$SortName = $DataParam ['SortName'];
			$SortOrder = $DataParam ['SortOrder'];
			
			if (! empty ( $this->SessionSortNameArr [strtolower ( $SortName )] ) && ! empty ( $this->SortOrderArr [strtolower ( $SortOrder )] )) {
				$sql .= " ORDER BY " . $this->SessionSortNameArr [strtolower ( $SortName )] . " " . $this->SortOrderArr [strtolower ( $SortOrder )];
			} else {
				$sql .= " ORDER BY PlayTime ASC, a.SessionID";
			}
		} else {
			$sql .= " ORDER BY PlayTime ASC, a.SessionID";
		}
		
		//分页数据
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$sql = $sql . " LIMIT " . $start . "," . $size;
			}
		}
		$result = DBMethodUtils::listData ( $sql );
		
		if (is_null ( $result ) || count ( $result ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array () );
			return;
		}
		if ($byweekday) {
			//筛选的是一周的某一天
			$newmodel = array ();
			$tempid = 1;
			
			foreach ( $result as $item ) {
				$newitem = array ();
				$newitem ["TempId"] = ($tempid ++);
				$newitem ["SessionID"] = $item ["SessionID"]; //	默认为0，主键ID
				$newitem ["SessionName"] = $item ["SessionName"]; //任务名称
				$newitem ["SessionType"] = $item ["SessionType"]; //	0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
				$newitem ["Priority"] = $item ["Priority"]; //	优先级
				$newitem ["ScheduleID"] = $item ["ScheduleID"];
				$newitem ["PlayTime"] = $item ["PlayTime"]; //任务指定的播放时间，仅使用时分秒
				$newitem ['SteamTypeDown'] = $item ['StreamType'] - round ( $item ['StreamType'] / 128 ) * 128; //00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
				$newitem ["TempFlag"] = $item ["TempFlag"]; //是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录
				$newitem ["Pause"] = $item ["Pause"]; //播出状态（仅广播才有），1暂停，0正在播放,null:没有播出状态
				$newitem ["FileName"] = $item ["FileName"]; //正在播放的文件的名字
				$newitem ["PlayListCount"] = $item ["PlayListCount"]; //播放文件数目
				

				if ($newitem ['SteamTypeDown'] == 0) {
					//控制任务需要获取设备状态
					//设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制
					$newitem ['SysEnabled'] = $item ['SysEnabled'];
					//扩展电源
					if (! is_null ( $item ['RfDevCtrl'] )) {
						//扩展设备信息
						$expandSource = ExpandUtil::LoadExpandDev ();
						//扩展设备模式
						$expandMode = ExpandUtil::LoadExpandMode ();
						
						$DeviceCtrl = DeviceUtil::DepackRfDevCtrl ( $expandSource, $item ['RfDevCtrl'], $expandMode );
						
						$newitem ['DeviceCtrl'] = $DeviceCtrl;
					}
				}
				$newmodel [count ( $newmodel )] = $newitem;
			}
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $newmodel );
		} else { //查看的是一周的全部
			$newmodel = array ();
			$tempid = 1;
			
			foreach ( $result as $item ) {
				$newitem = array ();
				
				$newitem ["SessionID"] = $item ["SessionID"]; //	默认为0，主键ID
				$newitem ["SessionName"] = $item ["SessionName"]; //任务名称
				$newitem ["SessionType"] = $item ["SessionType"]; //	0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
				$newitem ["Priority"] = $item ["Priority"]; //	优先级
				$newitem ["PlayTime"] = $item ["PlayTime"]; //任务指定的播放时间，仅使用时分秒
				$newitem ['SteamTypeDown'] = $item ['StreamType'] - round ( $item ['StreamType'] / 128 ) * 128; //00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
				//				$newitem ["TempFlag"] = $item ["TempFlag"]; //是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录
				$newitem ["PlayListCount"] = $item ["PlayListCount"]; //播放文件数目
				

				//获取播放时间
				for($i = 0; $i <= 6; $i ++) {
					$newitem ['Player_Weekday_' . $i] = null;
				}
				$sql = "SELECT ScheduleID, SessionID,WeekDay,TempFlag, DATE_FORMAT(PlayTime,'%H:%i:%S') as PlayTime FROM PlaySessionTime
				WHERE SessionID='" . $item ['SessionID'] . "' AND DATE_FORMAT(PlayTime,'%H:%i:%S')='" . $item ["PlayTime"] . "'";
				$PlayTimes = DBMethodUtils::listData ( $sql );
				
				//新建的一行，key1：周数，value：
				$newarr = array ();
				
				if (! is_null ( $PlayTimes )) {
					foreach ( $PlayTimes as $PlayTimesItem ) {
						$PlayTimesArr = array ("ScheduleID" => $PlayTimesItem ['ScheduleID'], "WeekDay" => $PlayTimesItem ['WeekDay'], "TempFlag" => $PlayTimesItem ['TempFlag'] );
						
						if (! empty ( $newitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] )) {
							//说明这一天已经有任务了，需要复制一条数据添加
							$hasadd = false;
							
							for($i = 0; $i < count ( $newarr ); $i ++) {
								if (! isset ( $newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] ) || is_null ( $newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] )) {
									//直接添加
									$newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
									
									$hasadd = true;
								}
							}
							if (! $hasadd) {
								//没有添加，需要复制一条记录
								$createitem = $newitem;
								
								for($i = 0; $i <= 6; $i ++) {
									$createitem ['Player_Weekday_' . $i] = null;
								}
								$createitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
								
								$newarr [count ( $newarr )] = $createitem;
							}
						} else {
							//这一天没有任务，可以添加
							$newitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
						}
					}
				}
				$newitem ["TempId"] = ($tempid ++);
				$newmodel [count ( $newmodel )] = $newitem;
				
				if (count ( $newarr ) > 0) {
					foreach ( $newarr as $newarritem ) {
						$newarritem ["TempId"] = ($tempid ++);
						$newmodel [count ( $newmodel )] = $newarritem;
					}
				}
			}
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $newmodel );
		}
	}
	
	/////////////////////////////////////////////////////////
	// 任务模板
	/////////////////////////////////////////////////////////
	/**
	 * 获取模板列表
	 */
	public function actionListTemplates() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT idTaskTemplate, IF (idTaskTemplate=0, '默认', TemplateName) AS TemplateName, IF(!ISNULL(b.InfoValue), 1, 0) AS Enabled FROM TaskTemplate a
			LEFT JOIN BaseInfo b ON a.idTaskTemplate=b.InfoValue AND InfomationID=257";
		
		if (! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			if (! empty ( $this->TemplateSortNameArr [strtolower ( $DataParam ['SortName'] )] ) && ! empty ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$sql .= " ORDER BY " . $this->TemplateSortNameArr [strtolower ( $DataParam ['SortName'] )] . " " . $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 编辑模板
	 */
	public function actionEditTemplate() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		//模板ID，如果是新建则不需要传值
		$TemplateID = null;
		
		if (isset ( $DataParam ['TemplateID'] )) {
			$TemplateID = $DataParam ['TemplateID'];
		}
		//模板名字
		$TemplateName = "";
		
		if (! isset ( $DataParam ['TemplateName'] ) || is_null ( $DataParam ['TemplateName'] ) || "" == trim ( $DataParam ['TemplateName'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$TemplateName = $DataParam ['TemplateName'];
		
		if (! is_null ( $TemplateID ) && is_numeric ( $TemplateID )) {
			//说明是修改模板
			$sql = 'Update TaskTemplate SET TemplateName="' . $TemplateName . '" WHERE idTaskTemplate="' . $TemplateID . '"';
			
			if (DBMethodUtils::RunSql ( $sql ) > 0) {
				echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '修改模板成功', null );
			} else {
				echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '修改模板失败', null );
			}
		} else {
			//新建模板
			$TaskTemplate = new TaskTemplate ();
			$TaskTemplate->TemplateName = $TemplateName;
			$TaskTemplate->Enabled = 0;
			
			if ($TaskTemplate->save ()) {
				echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '新建模板成功', null );
				return;
			}
			
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '新建模板失败', null );
		}
	}
	
	/**
	 * 模板启用/停用
	 */
	public function actionTemplateEnabled() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (! isset ( $DataParam ['TemplateID'] ) || ! isset ( $DataParam ['OpenFlag'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模板ID
		$TemplateID = $DataParam ['TemplateID'];
		//开始或关闭标识，0：关闭，1：开启
		$OpenFlag = $DataParam ['OpenFlag'];
		
		$sql = "SELECT * FROM TaskTemplate WHERE idTaskTemplate='" . $TemplateID . "'";
		$TaskTemplate = DBMethodUtils::findData ( $sql );
		
		if (is_null ( $TaskTemplate )) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '模板不存在，请确认！', null );
			return;
		}
		if ($OpenFlag == 1) { //开启
			$sql = "UPDATE BaseInfo SET InfoValue='" . $TaskTemplate ['idTaskTemplate'] . "' WHERE InfomationID=257";
			DBMethodUtils::RunSql ( $sql );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '启用模板成功', null );
		} else { //关闭模板
			$sql = "UPDATE BaseInfo SET InfoValue='-1' WHERE InfomationID=257 AND InfoValue='" . $TaskTemplate ['idTaskTemplate'] . "'";
			DBMethodUtils::RunSql ( $sql );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '停用模板成功', null );
		}
	}
	
	/**
	 * 删除模板
	 */
	public function actionDeleteTemplate() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		if (! isset ( $DataParam ['TemplateIDs'] ) || is_null ( $DataParam ['TemplateIDs'] ) || "" == trim ( $DataParam ['TemplateIDs'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//需要删除的模板ID，格式：1，2，3
		$TemplateIDs = $DataParam ['TemplateIDs'];
		//查询出模板内的任务，然后删除任务
		$sql = "SELECT * FROM PlaySessions WHERE Template IN(" . $TemplateIDs . ")";
		$Sessions = DBMethodUtils::listData ( $sql );
		
		$SessionIDs = "";
		if (! is_null ( $Sessions )) {
			foreach ( $Sessions as $item ) {
				$SessionIDs .= "," . $item ['SessionID'];
			}
			$SessionIDs = strlen ( $SessionIDs ) > 0 ? substr ( $SessionIDs, 1 ) : $SessionIDs;
		}
		TaskUtil::DeleteSessionByIDs ( $SessionIDs );
		
		//删除模板
		$sql = "DELETE FROM TaskTemplate WHERE idTaskTemplate IN(" . $TemplateIDs . ")";
		DBMethodUtils::RunSql ( $sql );
		
		//更新当前正在使用的模板
		$sql = "UPDATE BaseInfo SET InfoValue='-1' WHERE InfomationID=257 AND InfoValue IN(" . $TemplateIDs . ")";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '删除模板成功', null );
	}
	
	/////////////////////////////////////////////////////////
	//模式
	/////////////////////////////////////////////////////////
	/**
	 * 获取运行模式列表
	 */
	public function actionListRuningModeList() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = 'SELECT * FROM BroadcastMode WHERE Enabled=1';
		
		if (! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			if (! empty ( $this->ModeSortNameArr [strtolower ( $DataParam ['SortName'] )] ) && ! empty ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$sql .= " ORDER BY " . $this->ModeSortNameArr [strtolower ( $DataParam ['SortName'] )] . " " . $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 获取备用模式列表
	 */
	public function actionListReserveModeList() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = 'SELECT * FROM BroadcastMode WHERE Enabled=0';
		
		if (! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			if (! empty ( $this->ModeSortNameArr [strtolower ( $DataParam ['SortName'] )] ) && ! empty ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$sql .= " ORDER BY " . $this->ModeSortNameArr [strtolower ( $DataParam ['SortName'] )] . " " . $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 获取运行模式任务
	 */
	public function actionListRuningBroadcastmodes() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模式ID
		$ModeID = - 1;
		
		if (isset ( $DataParam ['ModeID'] )) {
			$ModeID = $DataParam ['ModeID'];
			
			if (! is_numeric ( $ModeID )) {
				$ModeID = - 1;
			}
		}
		//任务类型筛选,0:控制任务，1：广播任务，2：都选，3：都不选
		$StreamType = null;
		
		if (isset ( $DataParam ['SelectStreamType'] )) {
			$StreamType = $DataParam ['SelectStreamType'];
		}
		//排序
		$SortName = '';
		$SortOrder = '';
		
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] ) && ! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			$SortOrder = $DataParam ['SortOrder'];
			
			if (isset ( $this->SessionSortNameArr [strtolower ( $DataParam ['SortName'] )] )) {
				$SortName = $this->SessionSortNameArr [strtolower ( $DataParam ['SortName'] )];
			}
			
			if (isset ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$SortOrder = $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		//分页数据
		$page = "";
		
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$page = " LIMIT " . $start . "," . $size;
			}
		}
		
		$result = TaskUtil::LoadModeTask ( 1, $ModeID, $page, $UserID, $StreamType, $SortName, $SortOrder );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 获取备用模式任务
	 */
	public function actionListReserveBroadcastmodes() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		//模式ID
		$ModeID = - 1;
		
		if (isset ( $DataParam ['ModeID'] )) {
			$ModeID = $DataParam ['ModeID'];
			
			if (! is_numeric ( $ModeID )) {
				$ModeID = - 1;
			}
		}
		//任务类型筛选,0:控制任务，1：广播任务，2：都选，3：都不选
		$StreamType = null;
		
		if (isset ( $DataParam ['SelectStreamType'] )) {
			$StreamType = $DataParam ['SelectStreamType'];
		}
		//排序
		$SortName = '';
		$SortOrder = '';
		
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] ) && ! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			$SortOrder = $DataParam ['SortOrder'];
			
			if (isset ( $this->SessionSortNameArr [strtolower ( $DataParam ['SortName'] )] )) {
				$SortName = $this->SessionSortNameArr [strtolower ( $DataParam ['SortName'] )];
			}
			
			if (isset ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$SortOrder = $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		//分页数据
		$page = "";
		
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$page = " LIMIT " . $start . "," . $size;
			}
		}
		
		$result = TaskUtil::LoadModeTask ( 0, $ModeID, $page, $UserID, $StreamType, $SortName, $SortOrder );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 编辑模式（增加或修改）
	 */
	public function actionEditBroadcastmode() {
		
		/*
		 {
		 "idBroadcastMode":"广播模式ID",
		 "ModeName":"模式名",
		 "Priority":"优先级，默认是10",
		 "Enabled":"可用状态，默认是0不可用（备用模式），1可用（运行模式）。",
		 "StartTime":"开始时间,2015-10-28 18:00:00",
		 "StopTime":"结束时间,2015-11-28 18:00:00",
		 "TimeStyle":"时间类型，0的意思是通过开始时间和结束时间来代替一天的开始和结束（StartTime，StopTime使用年月日时分秒），另外的意思是周期性的，8位字节的低7位来代表一周7天，bit1星期一，bit2星期二，bit7表示星期天，以此类推（StartTime，StopTime仅使用时分秒）。默认是0仅一天",
		 "BrdModeMember":[
		 {
		 "DeviceID":"设备id（字符串）"
		 },
		 {
		 "DeviceID":"设备id（字符串）"
		 }
		 ]
		 }
		 */
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		
		if (! isset ( $_POST ['DataParam'] ) || is_null ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam ) || ! isset ( $DataParam ['idBroadcastMode'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$idBroadcastMode = $DataParam ['idBroadcastMode'];
		$new = false;
		
		if (is_numeric ( $idBroadcastMode ) && $idBroadcastMode > 0) {
			//修改模式
			$new = false;
			
			$UpdateParam = array ();
			$UpdateParam ["ModeName"] = $DataParam ["ModeName"]; //模式名",
			$UpdateParam ["Priority"] = $DataParam ["Priority"]; //优先级，默认是10",
			$UpdateParam ["Enabled"] = $DataParam ["Enabled"]; //可用状态，默认是0不可用（备用模式），1可用（运行模式）。",
			$UpdateParam ["StartTime"] = $DataParam ["StartTime"]; //开始时间,2015-10-28 18:00:00",
			$UpdateParam ["StopTime"] = $DataParam ["StopTime"]; //结束时间,2015-11-28 18:00:00",
			$UpdateParam ["TimeStyle"] = $DataParam ["TimeStyle"]; //时间类型，0的意思是通过开始时间和结束时间来代替一天的开始和结束（StartTime，StopTime使用年月日时分秒），另外的意思是周期性的，8位字节的低7位来代表一周7天，bit1星期一，bit2星期二，bit7表示星期天，以此类推（StartTime，StopTime仅使用时分秒）。默认是0仅一天",
			

			BroadcastMode::model ()->updateByPk ( $idBroadcastMode, $UpdateParam );
		} else {
			//新建模式
			$new = true;
			
			$BroadcastMode = new BroadcastMode ();
			
			$BroadcastMode->ModeName = $DataParam ["ModeName"]; //模式名",
			$BroadcastMode->Priority = $DataParam ["Priority"]; //优先级，默认是10",
			$BroadcastMode->Enabled = $DataParam ["Enabled"]; //可用状态，默认是0不可用（备用模式），1可用（运行模式）。",
			$BroadcastMode->StartTime = $DataParam ["StartTime"]; //开始时间,2015-10-28 18:00:00",
			$BroadcastMode->StopTime = $DataParam ["StopTime"]; //结束时间,2015-11-28 18:00:00",
			$BroadcastMode->TimeStyle = $DataParam ["TimeStyle"]; //时间类型，0的意思是通过开始时间和结束时间来代替一天的开始和结束（StartTime，StopTime使用年月日时分秒），另外的意思是周期性的，8位字节的低7位来代表一周7天，bit1星期一，bit2星期二，bit7表示星期天，以此类推（StartTime，StopTime仅使用时分秒）。默认是0仅一天",
			

			if (! $BroadcastMode->save ()) {
				
				echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '新建模式失败', null );
				return;
			}
			$idBroadcastMode = $BroadcastMode ['idBroadcastMode'];
		}
		//处理模式成员
		if (isset ( $DataParam ['BrdModeMember'] ) && ! is_null ( $DataParam ['BrdModeMember'] )) {
			$BrdModeMember = $DataParam ['BrdModeMember'];
			$UseDevIDs = "";
			
			foreach ( $BrdModeMember as $item ) {
				if (isset ( $item ['DeviceID'] )) {
					$UseDevIDs .= "," . $item ['DeviceID'];
				}
			}
			$UseDevIDs = strlen ( $UseDevIDs ) > 0 ? substr ( $UseDevIDs, 1 ) : $UseDevIDs;
			
			if (strlen ( $UseDevIDs ) > 0) {
				//删除不用的成员
				$sql = "DELETE FROM BrdModeMember WHERE BrdModeID='" . $idBroadcastMode . "' AND DeviceID NOT IN(" . $UseDevIDs . ")";
				DBMethodUtils::RunSql ( $sql );
			} else {
				$sql = "DELETE FROM BrdModeMember WHERE BrdModeID='" . $idBroadcastMode . "'";
				DBMethodUtils::RunSql ( $sql );
			}
			//查找已经拥有的成员
			$sql = "SELECT * FROM BrdModeMember WHERE BrdModeID='" . $idBroadcastMode . "'";
			$DBDevices = DBMethodUtils::listData ( $sql );
			
			$existMem = array ();
			
			if (! is_null ( $DBDevices ) && count ( $DBDevices ) > 0) {
				foreach ( $DBDevices as $item ) {
					$existMem [$item ['DeviceID']] = $item ['DeviceID'];
				}
			}
			foreach ( $BrdModeMember as $item ) {
				//添加接收成员
				if (isset ( $existMem [$item ['DeviceID']] ) && ! is_null ( $existMem [$item ['DeviceID']] )) {
					continue;
				}
				$BrdModeMember = new BrdModeMember ();
				$BrdModeMember->DeviceID = $item ['DeviceID'];
				$BrdModeMember->BrdModeID = $idBroadcastMode;
				
				$BrdModeMember->save ();
			}
		} else {
			//删除模式的所有成员
			$sql = "DELETE FROM BrdModeMember WHERE BrdModeID='" . $idBroadcastMode . "'";
			DBMethodUtils::RunSql ( $sql );
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, ($new ? '新建' : '修改') . '模式成功', null );
	}
	
	/**
	 * 删除模式
	 */
	public function actionDeleteBroadcastmode() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		if (! isset ( $DataParam ['idBroadcastModes'] ) || is_null ( $DataParam ['idBroadcastModes'] ) || "" == trim ( $DataParam ['idBroadcastModes'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模式id，格式：1，2，3
		$idBroadcastModes = $DataParam ['idBroadcastModes'];
		
		//查询出模式内的任务，然后删除任务
		$sql = "SELECT * FROM PlaySessions WHERE BrdMode IN(" . $idBroadcastModes . ")";
		$Sessions = DBMethodUtils::listData ( $sql );
		
		$SessionIDs = "";
		if (! is_null ( $Sessions )) {
			foreach ( $Sessions as $item ) {
				$SessionIDs .= "," . $item ['SessionID'];
			}
			$SessionIDs = strlen ( $SessionIDs ) > 0 ? substr ( $SessionIDs, 1 ) : $SessionIDs;
		}
		TaskUtil::DeleteSessionByIDs ( $SessionIDs );
		
		//删除模式成员
		$sql = "DELETE FROM BrdModeMember WHERE BrdModeID IN(" . $idBroadcastModes . ")";
		DBMethodUtils::RunSql ( $sql );
		
		//删除模式
		$sql = "DELETE FROM BroadcastMode WHERE idBroadcastMode IN(" . $idBroadcastModes . ")";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '删除模式成功', null );
	}
	
	/**
	 * 模式手动开始/手动停止
	 */
	public function actionBroadcastmodeOnOrOff() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		//管理员可手动启动或者停止模式的运行；
		if (! isset ( $DataParam ['idBroadcastModes'] ) || is_null ( $DataParam ['idBroadcastModes'] ) || trim ( $DataParam ['idBroadcastModes'] ) == '') {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模式id，格式：1，2，3
		$idBroadcastModes = $DataParam ['idBroadcastModes'];
		
		if (! isset ( $DataParam ['Active'] ) || ! is_numeric ( $DataParam ['Active'] ) || ($DataParam ['Active'] != 0 && $DataParam ['Active'] != 1)) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//开始/停止标识，1：开始，0：停止
		$Active = $DataParam ['Active'];
		$Active = $Active == 0 ? 0 : 1;
		
		//更新模式状态
		$sql = "UPDATE BroadcastMode SET Active='" . $Active . "' WHERE idBroadcastMode IN(" . $idBroadcastModes . ")";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, ($Active == 0 ? '手动停止' : '手动开始') . '参数异常', null );
	}
	
	/**
	 * 模式启用/停用
	 */
	public function actionBroadcastmodeEnabled() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (! isset ( $DataParam ['idBroadcastModes'] ) || is_null ( $DataParam ['idBroadcastModes'] ) || "" == trim ( $DataParam ['idBroadcastModes'] ) || ($DataParam ['Enabled'] != 0 && $DataParam ['Enabled'] != 1)) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模式id，格式：1，2，3
		$idBroadcastModes = $DataParam ['idBroadcastModes'];
		
		if (! isset ( $DataParam ['Enabled'] ) || ! is_numeric ( $DataParam ['Enabled'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//启用/停用标识，1：启用，0：停用
		$Enabled = $DataParam ['Enabled'];
		$Enabled = $Enabled == 0 ? 0 : 1;
		
		//更新模式状态
		$sql = "UPDATE BroadcastMode SET Enabled='" . $Enabled . "' WHERE idBroadcastMode IN(" . $idBroadcastModes . ")";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, ($Enabled == 0 ? '停用' : '启用') . '参数异常', null );
	}
	
	/**
	 * 粘贴任务模式
	 */
	public function actionPasteSessionMode() {
		
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (! isset ( $DataParam ['OldModeIDs'] ) || is_null ( $DataParam ['OldModeIDs'] ) || trim ( $DataParam ['OldModeIDs'] ) == '') {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		if (! isset ( $DataParam ['Enable'] ) || ! is_numeric ( $DataParam ['Enable'] ) || $DataParam ['Enable'] != 0 && $DataParam ['Enable'] != 1) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//拆分模式ID
		$arr = explode ( ',', $DataParam ['OldModeIDs'] );
		
		if (is_null ( $arr ) || count ( $arr ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		foreach ( $arr as $item ) {
			if (! is_numeric ( $item )) {
				continue;
			}
			try {
				//粘贴模式
				$sql = 'call sp_copy_mode(' . $item . ', ' . ($DataParam ['Enable'] == 1 ? 'true' : 'false') . ')';
				DBMethodUtils::RunSql ( $sql );
			} catch ( Exception $e ) {
			
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '模式粘贴成功', null );
		return;
	}
	/////////////////////////////////////////////////////////
	//手动任务
	/////////////////////////////////////////////////////////
	/**
	 * 获取手动任务
	 */
	public function actionListManualTasks() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT a.SessionID, a.SessionName, a.SessionType, a.Priority, a.CircleLength, a.StreamType, c.FileName, b.CurrFileProgress, b.CurrTotalProgress, dd.Pause
			FROM PlaySessions a LEFT JOIN PlayingSessions b ON a.SessionID=b.SessionID LEFT JOIN MediaFiles c ON b.PlayingFileID=c.MediaID
			 LEFT JOIN PlayingSessions dd ON a.SessionID=dd.SessionID WHERE a.SessionType IN(2,9)";
		
		//任务类型筛选,0:控制任务，1：广播任务，2：都选，3：都不选
		//		if (isset ( $DataParam ['SelectStreamType'] ) && is_numeric ( $DataParam ['SelectStreamType'] )) {
		//
		//			switch ($DataParam ['SelectStreamType']) {
		//				case 0 : //控制任务
		//					$sql = $sql . " AND a.StreamType&7 = 0";
		//					break;
		//				case 1 : //广播任务
		//					$sql = $sql . " AND a.StreamType&7 != 0";
		//					break;
		//				case 2 : //所有任务
		//					break;
		//				case 3 : //都不选
		//					$sql = $sql . " AND a.StreamType&7 = -1";
		//					break;
		//				default :
		//					break;
		//			}
		//		}
		//
		//		if (! is_null ( $UserID ) && $UserID > 0) {
		//			$sql .= ' AND Owner=' . $UserID;
		//		}
		

		//排序
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] )) {
			$SortName = $DataParam ['SortName'];
			$SortOrder = $DataParam ['SortOrder'];
			
			if (! empty ( $this->SessionSortNameArr [strtolower ( $SortName )] ) && ! empty ( $this->SortOrderArr [strtolower ( $SortOrder )] )) {
				$sql .= " ORDER BY " . $this->SessionSortNameArr [strtolower ( $SortName )] . " " . $this->SortOrderArr [strtolower ( $SortOrder )];
			}
		}
		
		//分页数据
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$sql = $sql . " LIMIT " . $start . "," . $size;
			}
		}
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	/////////////////////////////////////////////////////////
	//BW803
	/////////////////////////////////////////////////////////
	/**
	 * 获取BW803实时采播
	 */
	public function actionListRealTimeBw80x() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT SessionID, PlayerID as SessionName, SessionType, Priority, CircleLength
			FROM PlaySessions WHERE SessionType IN(10)";
		
		//排序
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] )) {
			$SortName = $DataParam ['SortName'];
			$SortOrder = $DataParam ['SortOrder'];
			
			if (! empty ( $this->SessionSortNameArr [strtolower ( $SortName )] ) && ! empty ( $this->SortOrderArr [strtolower ( $SortOrder )] )) {
				$sql .= " ORDER BY " . $this->SessionSortNameArr [strtolower ( $SortName )] . " " . $this->SortOrderArr [strtolower ( $SortOrder )];
			}
		}
		
		//分页数据
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$sql = $sql . " LIMIT " . $start . "," . $size;
			}
		}
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/////////////////////////////////////////////////////////
	//实时采播
	/////////////////////////////////////////////////////////
	/**
	 * 获取实时采播
	 */
	public function actionListRealTimeMining() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT a.SessionID, b.User_Desc as SessionName, a.SessionType, a.Priority, a.CircleLength
			FROM PlaySessions a LEFT JOIN Users b ON a.PlayerID = b.UsbKey WHERE SessionType IN(1, 10)";
		
		//排序
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] )) {
			$SortName = $DataParam ['SortName'];
			$SortOrder = $DataParam ['SortOrder'];
			
			if (! empty ( $this->SessionSortNameArr [strtolower ( $SortName )] ) && ! empty ( $this->SortOrderArr [strtolower ( $SortOrder )] )) {
				$sql .= " ORDER BY " . $this->SessionSortNameArr [strtolower ( $SortName )] . " " . $this->SortOrderArr [strtolower ( $SortOrder )];
			}
		}
		
		//分页数据
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$sql = $sql . " LIMIT " . $start . "," . $size;
			}
		}
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	///////////////////////////////////////////////
	public function actionTaskInfo() {
		
		$taskInfo = array ();
		
		//基本信息
		$baseInfo = array ();
		//任务id
		$baseInfo ['SessionID'] = "任务ID,如果是新建则为空字符串";
		//任务名称
		$baseInfo ['SessionName'] = "任务名字";
		//任务类型,0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
		$baseInfo ['SessionType'] = "0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务";
		//优先级
		$baseInfo ['Priority'] = "优先级（整数）";
		
		//强制接收标识(StreamType高4为来判断，最高位：1：强制，0：不强制)
		$baseInfo ['SteamTypeUp'] = "强制接收，1：强制，0：不强制";
		//00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
		$baseInfo ['SteamTypeDown'] = "0控制任务，1音频，2视屏，3音视频，一般用3来表示视频";
		$taskInfo ['BaseInfo'] = $baseInfo;
		
		//模式(不是模式任务则不需要传递这个值，也可以传空)
		$mode = array ();
		$mode ['BrdMode'] = "是否广播模式任务，>0广播模式ID 是模式任务，null表示非模式任务";
		$mode ['MemmberMode'] = "默认为0,是否使用模式成员，1使用模式成员，0不使用";
		$taskInfo ['Mode'] = $mode;
		
		//广播任务（不是广播任务则不需要传递这个值，也可以传空）
		$Brodcast = array ();
		//音量调节
		$Brodcast ['AudioGain'] = "音频增益，单个任务的音量调节。";
		//播放时间，秒
		$Brodcast ['CircleLength'] = "默认为0，播放时长；秒";
		//播放列表
		$Brodcast ['PlayFileList'] = array (array ('FileID' => "文件ID（整数）" ), array ('FileID' => "文件ID（整数）" ) );
		$taskInfo ['Brodcast'] = $Brodcast;
		
		//控制任务（不是制任务则不需要传递这个值，也可以传空）
		$DeviceCtrl = array ();
		//设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制
		$DeviceCtrl ['SysEnabled'] = "设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制";
		//扩展电源,没有控制则传空
		$DeviceCtrl ['RfDevCtrl'] = array (array ("PwrID" => "扩展设备ID", "Mode" => "模式：0：关闭电源；电源：1：打开电源，4：本地模式，其他无效；空调：1~4对应空调4种模式" ) );
		$taskInfo ['DeviceCtrl'] = $DeviceCtrl;
		
		//接收成员(模式，如果选择了模式成员，则可以不传值)
		$taskInfo ['SessionDevice'] = array (array ('DeviceID' => "设备id（字符串）" ), array ('DeviceID' => "设备id（字符串）" ) );
		
		//执行时间（手动任务可以不用传值）
		$taskInfo ['PlayTime'] = array (array ('ScheduleID' => '执行时间ID（整数）', 'WeekDay' => "星期编号，0：星期一，6：星期天", 'PlayTime' => "播出时间，仅时分秒，如：12:10:00", 'TempFlag' => '是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录', 'Pause' => '0 :停止, 1:播放，2：暂停' ) );
		
		echo CJSON::encode ( $taskInfo );
	}
	
	public function actionBroadcastmodeInfo() {
		
		$mode = array ();
		$mode ['idBroadcastMode'] = '广播模式ID';
		$mode ['ModeName'] = '模式名';
		$mode ['Priority'] = '优先级，默认是10';
		$mode ['Enabled'] = '可用状态，默认是0不可用（备用模式），1可用（运行模式）。';
		$mode ['StartTime'] = '开始时间,2015-10-28 18:00:00';
		$mode ['StopTime'] = '结束时间,2015-11-28 18:00:00';
		$mode ['TimeStyle'] = '时间类型，0的意思是通过开始时间和结束时间来代替一天的开始和结束（StartTime，StopTime使用年月日时分秒），另外的意思是周期性的，8位字节的低7位来代表一周7天，bit1星期一，bit2星期二，bit7表示星期天，以此类推（StartTime，StopTime仅使用时分秒）。默认是0仅一天';
		
		//模式成员
		$mode ['BrdModeMember'] = array (array ('DeviceID' => "设备id（字符串）" ), array ('DeviceID' => "设备id（字符串）" ) );
		
		echo CJSON::encode ( $mode );
	}
	
	public function actionSessionBroadcastOptInfo() {
		
		$mode = array ();
		$mode [count ( $mode )] = array ('SessionID' => '任务ID', 'ScheduleID' => '播出时间ID' );
		
		echo CJSON::encode ( $mode );
	}

	//	
//	//////////////////////////////////////////////////////////////////
//	// WEB
//	//////////////////////////////////////////////////////////////////
//	/**
//	 * 获取定时任务列表
//	 */
//	public function actionListTimeTasksForWeb() {
//		
//		$UserID = $this->GetPostOwnerID ();
//		
//		if (! is_null ( $UserID ) && $UserID < 0) {
//			//用户无效
//			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
//			return;
//		}
//		if (! isset ( $_POST ['DataParam'] )) {
//			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
//			return;
//		}
//		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
//		
//		if (is_null ( $DataParam )) {
//			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
//			return;
//		}
//		$sql = "SELECT a.SessionID, a.ScheduleID, DATE_FORMAT(a.PlayTime,'%H:%i:%S') as PlayTime, b.CircleLength, a.TempFlag,
//			IF(" . (is_null ( $UserID ) ? 0 : $UserID) . " <= 0, IF((ISNULL(uu.User_Name) OR LENGTH(uu.User_Name) < 1), b.SessionName, CONCAT(uu.User_Name, ':',b.SessionName)), b.SessionName) SessionName
//			, b.SessionType, b.Priority, b.StreamType, b.SysEnabled, b.RfDevCtrl, dd.Pause,mf.FileName, IF(ISNULL(pl.PlayListCount), 0, pl.PlayListCount) AS PlayListCount 
//			FROM PlaySessionTime a LEFT JOIN PlaySessions b ON a.SessionID=b.SessionID 
//			LEFT JOIN PlayingSessions dd ON a.SessionID=dd.SessionID AND a.ScheduleID=dd.ScheduleID LEFT JOIN PlayingSessions ps ON a.SessionID=ps.SessionID 
//			LEFT JOIN MediaFiles mf ON ps.PlayingFileID=mf.MediaID LEFT JOIN Users uu ON b.Owner=uu.User_ID
//			LEFT JOIN (SELECT COUNT(*) AS PlayListCount, SessionID FROM PlayListFiles GROUP BY SessionID) pl ON a.SessionID=pl.SessionID
//			WHERE SessionType IN (0,8)";
//		
//		//任务类型筛选,0:控制任务，1：广播任务，2：都选，3：都不选
//		if (isset ( $DataParam ['SelectStreamType'] ) && is_numeric ( $DataParam ['SelectStreamType'] )) {
//			
//			switch ($DataParam ['SelectStreamType']) {
//				case 0 : //控制任务
//					$sql = $sql . " AND b.StreamType&7 = 0";
//					break;
//				case 1 : //广播任务
//					$sql = $sql . " AND b.StreamType&7 != 0";
//					break;
//				case 2 : //所有任务
//					break;
//				case 3 : //都不选
//					$sql = $sql . " AND b.StreamType&7 = -1";
//					break;
//				default :
//					break;
//			}
//		}
//		$OwnerWhere = array ();
//		
//		if ($UserID > 0) { //非最高权限管理员
//			$OwnerWhere [] = " b.Owner = '" . $UserID . "'";
//		}
//		$Owner = - 1;
//		
//		if (isset ( $DataParam ['Owner'] ) && is_numeric ( $DataParam ['Owner'] )) { //按照任务所属人筛选
//			$Owner = $DataParam ['Owner'];
//		}
//		
//		//任务创建者的id
//		if (! is_null ( $Owner ) && $Owner > 0) {
//			$OwnerWhere [] = " b.Owner = '" . $UserID . "'";
//		}
//		if (! empty ( $OwnerWhere )) {
//			$sql .= ' AND (' . implode ( ' OR ', $OwnerWhere ) . ')';
//		}
//		//按照星期筛选
//		$byweekday = false;
//		
//		if (isset ( $DataParam ['WeekDay'] )) {
//			$WeekDay = $DataParam ['WeekDay'];
//			
//			if (is_numeric ( $WeekDay )) {
//				$sql = $sql . " AND WeekDay = '" . $WeekDay . "'";
//				$byweekday = true;
//			}
//		}
//		if (is_null ( $UserID )) { //TODO 需要考虑是否需要模板
//			//按照模板筛选(定时任务不需要传递这个值)
//			if (isset ( $DataParam ['Template'] ) && is_numeric ( $DataParam ['Template'] )) {
//				$sql .= " and Template='" . $DataParam ['Template'] . "'";
//			} else {
//				$sql .= " and Template=(SELECT InfoValue FROM BaseInfo WHERE InfomationID=257)";
//			}
//		}
//		
//		//搜索关键字,按照名字搜索
//		if (isset ( $DataParam ['SearchKey'] ) && "" != trim ( $DataParam ['SearchKey'] )) {
//			$sql .= " AND SessionName like '%" . $DataParam ['SearchKey'] . "%'";
//		}
//		$sql = $sql . " GROUP BY a.SessionID,DATE_FORMAT(a.PlayTime,'%H:%i:%S')";
//		
//		//获取总数
//		$Count = 0;
//		$CountSql = 'SELECT COUNT(*) c FROM (' . $sql . ') CC';
//		$TempData = DBMethodUtils::findData ( $CountSql );
//		
//		if (! empty ( $TempData )) {
//			$Count = $TempData ['c'];
//		}
//		
//		//排序
//		$SortFlag = false;
//		
//		if (! empty ( $_POST ['sort'] ) && ! empty ( $_POST ['order'] )) {
//			$Sort = $_POST ['sort'];
//			$Order = $_POST ['order'];
//			
//			//可排序的字段
//			$SortCol = array ("PlayTime", "SessionName", "Priority", "SysEnabled" );
//			
//			//			if ($Sort == "text") {
//			//				$Sort = "Dev_Name";
//			//			} else if ($Sort == "State_Online") {
//			//				$Sort = "State_SysPower";
//			//			} else 
//			if (! in_array ( $Sort, $SortCol )) {
//				$Sssql = "SELECT * FROM PwrDisplaySet WHERE Name='" . $Sort . "'";
//				$tempdata = DBMethodUtils::findData ( $Sssql );
//				
//				if (! empty ( $tempdata )) {
//					$Sort = "RfDevCtrl";
//				}
//			}
//			$SortCol [] = "RfDevCtrl";
//			
//			if (in_array ( strtolower ( $Order ), array ('asc', 'desc' ) ) && in_array ( $Sort, $SortCol )) {
//				$sql .= " ORDER BY " . $Sort . " " . $Order;
//				$SortFlag = true;
//			}
//		}
//		
//		if (! $SortFlag) {
//			$sql .= " ORDER BY PlayTime ASC";
//		}
//		
//		//		//排序
//		//		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] )) {
//		//			$SortName = $DataParam ['SortName'];
//		//			$SortOrder = $DataParam ['SortOrder'];
//		//			
//		//			if (! empty ( $this->SessionSortNameArr [strtolower ( $SortName )] ) && ! empty ( $this->SortOrderArr [strtolower ( $SortOrder )] )) {
//		//				$sql .= " ORDER BY " . $this->SessionSortNameArr [strtolower ( $SortName )] . " " . $this->SortOrderArr [strtolower ( $SortOrder )];
//		//			} else {
//		//				$sql .= " ORDER BY PlayTime ASC";
//		//			}
//		//		} else {
//		//			$sql .= " ORDER BY PlayTime ASC";
//		//		}
//		//分页数据
//		if (isset ( $_POST ['page'] ) && isset ( $_POST ['rows'] ) && is_numeric ( $_POST ['page'] ) && is_numeric ( $_POST ['rows'] )) {
//			$page = $_POST ['page'];
//			$size = $_POST ['rows'];
//			$start = ($page - 1) * $size;
//			$sql = $sql . " LIMIT " . $start . "," . $size;
//		}
//		//		
//		//		//分页数据
//		//		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
//		//			$start = $DataParam ['Start'];
//		//			$size = $DataParam ['Size'];
//		//			
//		//			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
//		//				$sql = $sql . " LIMIT " . $start . "," . $size;
//		//			}
//		//		}
//		$result = DBMethodUtils::listData ( $sql );
//		
//		if (is_null ( $result ) || count ( $result ) <= 0) {
//			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array () );
//			return;
//		}
//		if ($byweekday) {
//			//筛选的是一周的某一天
//			$newmodel = array ();
//			$tempid = 1;
//			
//			foreach ( $result as $item ) {
//				$newitem = array ();
//				$newitem ["TempId"] = ($tempid ++);
//				$newitem ["SessionID"] = $item ["SessionID"]; //	默认为0，主键ID
//				$newitem ["SessionName"] = $item ["SessionName"]; //任务名称
//				$newitem ["SessionType"] = $item ["SessionType"]; //	0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
//				$newitem ["Priority"] = $item ["Priority"]; //	优先级
//				$newitem ["ScheduleID"] = $item ["ScheduleID"];
//				$newitem ["PlayTime"] = $item ["PlayTime"]; //任务指定的播放时间，仅使用时分秒
//				$newitem ['SteamTypeDown'] = $item ['StreamType'] - round ( $item ['StreamType'] / 128 ) * 128; //00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
//				$newitem ["TempFlag"] = $item ["TempFlag"]; //是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录
//				$newitem ["Pause"] = $item ["Pause"]; //播出状态（仅广播才有），1暂停，0正在播放,null:没有播出状态
//				$newitem ["FileName"] = $item ["FileName"]; //正在播放的文件的名字
//				$newitem ["PlayListCount"] = $item ["PlayListCount"]; //播放文件数目
//				
//
//				if ($newitem ['SteamTypeDown'] == 0) {
//					//控制任务需要获取设备状态
//					//设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制
//					$newitem ['SysEnabled'] = $item ['SysEnabled'];
//					//扩展电源
//					if (! is_null ( $item ['RfDevCtrl'] )) {
//						//扩展设备信息
//						$expandSource = ExpandUtil::LoadExpandDev ();
//						//扩展设备模式
//						$expandMode = ExpandUtil::LoadExpandMode ();
//						
//						$DeviceCtrl = DeviceUtil::DepackRfDevCtrl ( $expandSource, $item ['RfDevCtrl'], $expandMode );
//						
//						$newitem ['DeviceCtrl'] = $DeviceCtrl;
//					}
//				}
//				$newmodel [count ( $newmodel )] = $newitem;
//			}
//			//获取总数
//			$Out = array ('Total' => $Count, 'Rows' => $newmodel );
//			
//			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
//		} else { //查看的是一周的全部
//			$newmodel = array ();
//			$tempid = 1;
//			
//			foreach ( $result as $item ) {
//				$newitem = array ();
//				
//				$newitem ["SessionID"] = $item ["SessionID"]; //	默认为0，主键ID
//				$newitem ["SessionName"] = $item ["SessionName"]; //任务名称
//				$newitem ["SessionType"] = $item ["SessionType"]; //	0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
//				$newitem ["Priority"] = $item ["Priority"]; //	优先级
//				$newitem ["PlayTime"] = $item ["PlayTime"]; //任务指定的播放时间，仅使用时分秒
//				$newitem ['SteamTypeDown'] = $item ['StreamType'] - round ( $item ['StreamType'] / 128 ) * 128; //00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
//				//				$newitem ["TempFlag"] = $item ["TempFlag"]; //是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录
//				$newitem ["PlayListCount"] = $item ["PlayListCount"]; //播放文件数目
//				
//
//				//获取播放时间
//				for($i = 0; $i <= 6; $i ++) {
//					$newitem ['Player_Weekday_' . $i] = null;
//				}
//				$sql = "SELECT ScheduleID, SessionID,WeekDay,TempFlag, DATE_FORMAT(PlayTime,'%H:%i:%S') as PlayTime FROM PlaySessionTime
//				WHERE SessionID='" . $item ['SessionID'] . "' AND DATE_FORMAT(PlayTime,'%H:%i:%S')='" . $item ["PlayTime"] . "'";
//				$PlayTimes = DBMethodUtils::listData ( $sql );
//				
//				//新建的一行，key1：周数，value：
//				$newarr = array ();
//				
//				if (! is_null ( $PlayTimes )) {
//					foreach ( $PlayTimes as $PlayTimesItem ) {
//						$PlayTimesArr = array ("ScheduleID" => $PlayTimesItem ['ScheduleID'], "WeekDay" => $PlayTimesItem ['WeekDay'], "TempFlag" => $PlayTimesItem ['TempFlag'] );
//						
//						if (! empty ( $newitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] )) {
//							//说明这一天已经有任务了，需要复制一条数据添加
//							$hasadd = false;
//							
//							for($i = 0; $i < count ( $newarr ); $i ++) {
//								if (! isset ( $newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] ) || is_null ( $newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] )) {
//									//直接添加
//									$newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
//									
//									$hasadd = true;
//								}
//							}
//							if (! $hasadd) {
//								//没有添加，需要复制一条记录
//								$createitem = $newitem;
//								
//								for($i = 0; $i <= 6; $i ++) {
//									$createitem ['Player_Weekday_' . $i] = null;
//								}
//								$createitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
//								
//								$newarr [count ( $newarr )] = $createitem;
//							}
//						} else {
//							//这一天没有任务，可以添加
//							$newitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
//						}
//					}
//				}
//				$newitem ["TempId"] = ($tempid ++);
//				$newmodel [count ( $newmodel )] = $newitem;
//				
//				if (count ( $newarr ) > 0) {
//					foreach ( $newarr as $newarritem ) {
//						$newarritem ["TempId"] = ($tempid ++);
//						$newmodel [count ( $newmodel )] = $newarritem;
//					}
//				}
//			}
//			//获取总数
//			$Out = array ('Total' => $Count, 'Rows' => $newmodel );
//			
//			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
//		}
//	}


}
