<?php
class UpdateController extends ServerController {
	
	/**
	 * 获取设备状态
	 * @param $UserID
	 * @param $DeviceID
	 * @param $expandSource
	 * @param $expandMode
	 */
	public function LoadDevicestatus($UserID, $DeviceID, $expandSource, $expandMode) {
		
		$sql = 'select a.DevID,a.Dev_Name,a.Dev_Description,b.DeviceStatus, b.ActualSessionID,b.State_SysPower,b.State_ProjectorStatus, 
			b.State_ProjectorLampStatus,b.State_ExDevice1Status, b.State_ExDevice2Status,b.State_CurrProjectorSrc,
			b.State_CurrAudio,b.State_CurrAudioVolume,b.State_CurrMicVolume, b.State_FaultStatus,b.State_MicState,b.State_Mute,b.State_CentralUsedTime,
			b.State_ProjectorUsedTime,b.State_LightUsedTime,b.IpAddress, b.Cfg_System, b.Cfg_Remark, e.SessionID,c.SessionName, d.ModeName, a.Parent, 
			b.RfDevStatus, c.StreamType, f.User_Desc
			FROM DeviceList a 
			LEFT JOIN DeviceStatus b on a.DevID = b.DeviceID 
			LEFT JOIN PlaySessions c on c.SessionID=b.ActualSessionID 
			LEFT JOIN BroadcastMode d on d.idBroadcastMode = get_dev_mode(a.DevID) 
			LEFT JOIN DeviceDesiredStaus e on e.DeviceID = a.DevID 
			LEFT JOIN Users f ON b.User_ID = f.User_ID';

        $User = Users::model ()->findByPk ( $UserID );
        if (! is_null ( $UserID ) && $UserID > 0 && $User['Mgr_Privilege'] != 1) {
			$sql .= ' RIGHT JOIN UserDevices g ON g.UserID = ' . $UserID . ' AND g.Pri & ' . SystemUtil::getUserDevMask("1") . ' > 0 AND a.DevID = g.DevID ';
		}
		$sql .= ' WHERE a.DevID = "' . $DeviceID . '"';
		$DeviceStatus = DBMethodUtils::findData ( $sql );
		
		if (! is_null ( $DeviceStatus ) && isset ( $DeviceStatus ['DevID'] )) {
			$item = DeviceUtil::PackDevice ( $DeviceStatus, $expandSource, $expandMode );
			
			if (! empty ( $item ) && ! empty ( $DeviceStatus )) {
				$SteamTypeUp = round ( $DeviceStatus ['StreamType'] / 128 );
				$item ['SteamTypeUp'] = $SteamTypeUp == 1 ? 1 : 0;
			}
			return $item;
		}
		
		return null;
	}
	
	/**
	 * 获取任务状态
	 * @param $UserID 用户ID
	 * @param $SessionID 任务ID
	 * @param $ScheduleID 任务执行时间ID
	 */
	public function LoadSessionstatus($UserID, $SessionID, $ScheduleID) {
		
		$sql = 'SELECT a.*, b.Pause, mf.FileName FROM PlaySessions a LEFT JOIN PlayingSessions b ON a.SessionID=b.SessionID
			 LEFT JOIN MediaFiles mf ON b.PlayingFileID=mf.MediaID WHERE a.SessionID="' . $SessionID . '"';
		$Session = DBMethodUtils::findData ( $sql );
		
		if (! is_null ( $Session )) {
			$res = array ();
			$res ['SessionID'] = $Session ['SessionID'];
			$res ['Pause'] = $Session ['Pause'];
			$res ['FileName'] = empty ( $Session ['FileName'] ) ? '' : $Session ['FileName'];
			$res ['ScheduleID'] = 0;
			$res ['PlayTime'] = '';
			$res ['TempFlag'] = - 1;
			
			$sql = 'SELECT ScheduleID, DATE_FORMAT(PlayTime, "%H:%i:%S") as PlayTime, TempFlag FROM PlaySessionTime WHERE ScheduleID="' . $ScheduleID . '" AND SessionID="' . $SessionID . '"';
			$PlayeTime = DBMethodUtils::findData ( $sql );
			
			if (! is_null ( $PlayeTime )) {
				$res ['ScheduleID'] = $PlayeTime ['ScheduleID'];
				$res ['PlayTime'] = $PlayeTime ['PlayTime'];
				$res ['TempFlag'] = $PlayeTime ['TempFlag'];
			}
			
			return $res;
		}
		
		return null;
	}
	
	/**
	 * 更新信息
	 */
	public function actionLoadUpdateInfo() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (is_null ( $UserID )) {
			$UserID = 0;
		}
		//最后一条消息的ID
		$LastID = 0;
		
		if (isset ( $DataParam ['LastID'] ) && is_numeric ( $DataParam ['LastID'] )) {
			$LastID = $DataParam ['LastID'];
		}
		
		$sql = 'SELECT ID,MsgFrom, MsgType, MsgTime, CmdType, CmdObjType, CmdObjID, CmdObjIP FROM Messages WHERE (ID >' . $LastID . ') AND (MsgTo = 2) ORDER BY ID';
		$MsgList = DBMethodUtils::listData ( $sql );
		
		$Devices = array ();
		$Tasks = array ();
		
		if (! is_null ( $MsgList ) && count ( $MsgList ) > 0) {
			//查询扩展电源信息
			$expandSource = null;
			//加载扩展电源的模式
			$expandMode = null;
			
			foreach ( $MsgList as $item ) {
				if ($item ['ID'] > $LastID) {
					$LastID = $item ['ID'];
				}
				$DeviceID = $item ['CmdObjID'];
				
				switch ($item ['MsgType']) {
					case 3 : //设备，任务（定时、模板、模式）
						///////////////////////////////////////////////////////////
						if (is_null ( $expandSource ) || is_null ( $expandMode )) {
							$expandSource = ExpandUtil::LoadExpandDev ();
							$expandMode = ExpandUtil::LoadExpandMode ();
						}
						$DeviceStatus = $this->LoadDevicestatus ( $UserID, $DeviceID, $expandSource, $expandMode );
						
						if (! is_null ( $DeviceStatus )) {
							$Devices [count ( $Devices )] = $DeviceStatus;
						}
						///////////////////////////////////////////////////////////
						if (DeviceUtil::GetDevType ( $DeviceID ) == DeviceUtil::DEV_TYPE_PC_CALLER || DeviceUtil::GetDevType ( $DeviceID ) == DeviceUtil::DEV_TYPE_EMBEDED_CALLER) {
						
						}
						break;
					case 10 : //任务（需要更新任务状态，是否临时，播出状态）
						$tempdata = $this->LoadSessionstatus ( $UserID, $item ['CmdType'], $item ['CmdObjType'] );
						
						if (! is_null ( $tempdata )) {
							$Tasks [count ( $Tasks )] = $tempdata;
						}
						break;
					case 9 : //任务（定时、模板、模式）
						break;
					case 12 : //导航树
						

						break;
					default :
						break;
				}
			}
		}
		$res = array ('LastID' => $LastID, 'RefreshTime' => '5', 'Devices' => $Devices, 'Tasks' => $Tasks );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $res );
	}
}