<?php
/**
 * 权限校验
 *
 */
class PermissionManager {
	
	/**
	 * 判断用户是否有多媒体平台控制权限(中控设备的管理权限)
	 * @param $UserId 用户ID
	 * @return true : 有权限，false：没有权限
	 */
	public static function JudgeDevCtrPrivaliege($privilege) {
		
		if (empty($privilege)) {
			return false;
		}
		//权限掩码
		$mask = 1;
		
		if (($privilege & $mask) > 0) {
			return true;
		}
		
		return false;
	}

	/**
	 * 判断是否具有IC卡管理权限 
	 * @param $UserId
	 * @param $privilege
	 */
	public static function JudgeICMgrPrivaliege($privilege) {
		
		if (empty($privilege)) {
			return false;
		}
		//权限掩码
		$mask = 16;
		
		if (($privilege & $mask) > 0) {
			return true;
		}
		
		return false;
	}
	
	/**
	 * 浏览权限
	 * @param $UserId
	 * @param $privilege
	 */
	public static function JudgeScanPrivaliege($privilege) {
		
		if (empty($privilege)) {
			return false;
		}
		//权限掩码
		$mask = 32;
		
		if (($privilege & $mask) > 0) {
			return true;
		}
		
		return false;
	}

    /**
     * 判断用户是否有IP呼叫权限标志
     * @param $UserId 用户ID
     */
    public static function JudgeIpcallPrivaliege($privilege) {

        if (empty($privilege)) {
            return false;
        }
        if (($privilege & 0x200) > 0) {
            return true;
        }
        return false;
    }

	/**
	 * 判断用户是否有广播权限权限
	 * @param $UserId 用户ID
	 */
	public static function JudgeBroadcastPrivaliege($privilege) {
		
		if (empty($privilege)) {
			return false;
		}
		//权限掩码
		$mask = 256;
		
		if (($privilege & $mask) > 0) {
			return true;
		}
		
		return false;
	}
	
	/**
	 * 判断用户是否有物联设备权限权限
	 * @param $UserId 用户ID
	 */
	public static function JudgeRfDevCtrPrivaliege($privilege) {
		
		if (empty($privilege)) {
			return false;
		}
		//权限掩码
		$mask = 65536;
		
		if (($privilege & $mask) > 0) {
			return true;
		}
		
		return false;
	}

}