<?php

/**
 * This is the model class for table "DeviceDesiredStaus".
 *
 * The followings are the available columns in table 'DeviceDesiredStaus':
 * @property string $DeviceID
 * @property integer $SessionID
 * @property integer $BrdPort
 * @property integer $BrdMode
 * @property integer $SessionValid
 * @property integer $SessionType
 * @property integer $StreamType
 * @property integer $ModePriority
 * @property integer $SysEnabled
 * @property string $RfDevCtrl
 */
class DeviceDesiredStaus extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'DeviceDesiredStaus';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('DeviceID', 'required'),
			array('SessionID, BrdPort, BrdMode, SessionValid, SessionType, StreamType, ModePriority, SysEnabled', 'numerical', 'integerOnly'=>true),
			array('DeviceID', 'length', 'max'=>50),
			array('RfDevCtrl', 'length', 'max'=>16),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('DeviceID, SessionID, BrdPort, BrdMode, SessionValid, SessionType, StreamType, ModePriority, SysEnabled, RfDevCtrl', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'DeviceID' => 'Device',
			'SessionID' => 'Session',
			'BrdPort' => 'Brd Port',
			'BrdMode' => 'Brd Mode',
			'SessionValid' => 'Session Valid',
			'SessionType' => 'Session Type',
			'StreamType' => 'Stream Type',
			'ModePriority' => 'Mode Priority',
			'SysEnabled' => 'Sys Enabled',
			'RfDevCtrl' => 'Rf Dev Ctrl',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('DeviceID',$this->DeviceID,true);
		$criteria->compare('SessionID',$this->SessionID);
		$criteria->compare('BrdPort',$this->BrdPort);
		$criteria->compare('BrdMode',$this->BrdMode);
		$criteria->compare('SessionValid',$this->SessionValid);
		$criteria->compare('SessionType',$this->SessionType);
		$criteria->compare('StreamType',$this->StreamType);
		$criteria->compare('ModePriority',$this->ModePriority);
		$criteria->compare('SysEnabled',$this->SysEnabled);
		$criteria->compare('RfDevCtrl',$this->RfDevCtrl,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return DeviceDesiredStaus the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
