<?php
class WebAdminBaseController extends BaseController {

	//是否是测试模式
	private $IsTest = true;
    //特殊控制器，由控制器自己处理参数
    private $SpecialController = array('camera');
	//不需要校验的登陆的Action
	private $NotNeedLoginAction = array ('user/login', 'sync/schooldata', 'sync/userdata', 'config/loadip' );
	//不需要校验的前签名的Action,只有登陆了后才需要校验
	private $NoSignAction = array ('user/login', 'sync/schooldata', 'sync/userdata', 'config/loadip' );
	//同步间隔时间，30分钟
	private $SyncTime = 1800;

	//是否可以同时登陆


	/**
	 * @see CController::beforeAction()
	 */
	public function beforeAction($action) {
        //特殊处理
        if(in_array($action->getController()->getId(), $this->SpecialController)){
            return true;
        }
		$_POST ['UserID'] = Yii::app()->request->getPost("UserID", "", true);
		$_POST ['Session'] = Yii::app()->request->getPost("Session", "", true);
		$_POST ['DataParam'] = Yii::app()->request->getPost("DataParam", "", true);

		$AccessAction = strtolower ( $action->getController ()->getId () . '/' . $action->getId () );

		if ($this->IsTest && (! isset ( $_POST ['UserID'] ) || ! is_numeric ( $_POST ['UserID'] ))) {
			$_POST ['UserID'] = 0;
		}
		//设置当前语言
		Yii::app ()->language = ToolUtil::WriteOrReadLanguage ( '', LanguageUtil::getUserId (), true );

		if (! $this->IsTest & ! in_array ( $AccessAction, $this->NotNeedLoginAction )) { //需要校验是否登陆
			//校验用户登陆
			if (! isset ( $_POST ['UserID'] ) || ! isset ( $_POST ['Session'] )) {
				echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '需要登陆', null );
				return false;
			}
			$UserID = $_POST ['UserID'];
			$Session = $_POST ['Session'];
				
			if (!is_numeric($UserID) || $UserID < 0 || empty($Session)) {
				echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '需要登陆', null );
				return false;
			}
				
			//更新用户缓存
			$data = CacheUtil::GetCache ( CacheUtil::$WEB_USER_CACHE_ID . $UserID );

			if (empty($data)) { //用户缓存不存在
				echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '需要登陆' . CacheUtil::$WEB_USER_CACHE_ID . $UserID, null );
				return false;
			} else {
				//校验登录Ip
				//				if (! isset ( $data ['Ip'] ) || $data ['Ip'] != ToolUtil::GetClientIp ()) {
				//					echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '需要登陆', null );
				//					return false;
				//				}
				//更新用户缓存
				//				CacheUtil::SetCache ( CacheUtil::$WEB_USER_CACHE_ID . $UserID, $data );
			}

			//			if (! isset ( $data ['Session'] ) || $data ['Session'] != $Session) { //Session数据不一致
			//				echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '需要登陆', null );
			//				return false;
			//			}
			//
			//			if (! in_array ( $AccessAction, $this->NoSignAction )) { //需要校验签名
			//				if (! isset ( $data ['SignKey'] ) || ! isset ( $_POST ['DataParam'] ) || ! isset ( $_POST ['SignData'] )) {
			//					echo $this->PackResponseData ( ErrcodeUtil::$SIGN_ERR, '鉴权失败', null );
			//					return false;
			//				}
			//				$PostData = 'UserID=' . $UserID . '&Session=' . $Session . '&Key=' . $data ['SignKey'] . '&DataParam=' . $_POST ['DataParam'];
			//				$SignData = md5 ( $PostData );
			//
			//				if (strtolower ( $SignData ) != strtolower ( $_POST ['SignData'] )) { //鉴权失败
			//					echo $this->PackResponseData ( ErrcodeUtil::$SIGN_ERR, '鉴权失败', null );
			//					return false;
			//				}
			//			} else {
			//				//更新用户缓存
			//				CacheUtil::SetCache ( CacheUtil::$WEB_USER_CACHE_ID . $UserID, $data );
			//
			//			}
		}

		return true;
	}

	/****************************************************************/
	//设备排序方式
	protected $SortOrderArr = array ('asc' => 'ASC', //升序
'desc' => 'DESC' ); //降序
}
