<?php
class LogController extends WebAdminBaseController {
	
	/**
	 * 加载设备日志 
	 */
	public function actionListDeviceLog() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		// 日志开始时间
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		// 日志结束时间,年月日；2015-12-24
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		if (is_null ( $endTime ) || is_null ( $beginTime ) || "" == trim ( $endTime ) || "" == trim ( $beginTime ) || $endTime < $beginTime) {
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_ENDTIME_MUSTBIG, '结束时间必须大于开始时间，请确认！', null );
			return;
		}
		$ParamArr = array ();
		$sql = ALogUtils::getListDeviceLogSql ( $UserID, $DataParam, $ParamArr );
		
		if (empty ( $sql )) {
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array ('Total' => 0, 'Rows' => array () ) );
			return;
		}
		
		//获取总数
		$CountSql = "SELECT COUNT(*) c FROM (" . $sql . ") cc";
		$AllCount = 0;
		$AllCountData = DBMethodUtils::findData ( $CountSql, $ParamArr );
		
		if (! empty ( $AllCountData ['c'] )) {
			$AllCount = $AllCountData ['c'];
		}
		
		// 排序
		$SortFlag = false;
		$sortArr = array ();
		$Sort = "";
		$Order = "";
		
		if (! empty ( $_POST ['sort'] ) && ! empty ( $_POST ['order'] )) {
			$Sort = $_POST ['sort'];
			$Order = $_POST ['order'];
		} else if (! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			$Sort = $DataParam ['SortName'];
			$Order = $DataParam ['SortOrder'];
		} else if (! empty ( $DataParam ['sort'] ) && ! empty ( $DataParam ['order'] )) {
			$Sort = $DataParam ['sort'];
			$Order = $DataParam ['order'];
		}
		
		if (! empty ( $Sort )) {
			//可排序的字段
			$SortCol = array ('DevID', 'Dev_Name', 'CtrlUser', 'User_Name', 'User_Desc', 'DateTime', 'EndTime', 'Event', 'MsgContext' );
			
			if (! in_array ( $Sort, $SortCol )) {
				if ('Duration' == $Sort) {
					$Sort = '(UNIX_TIMESTAMP(a.EndTime) - UNIX_TIMESTAMP(a.DateTime))';
				} else {
					$Sort = 'DevLogID';
				}
			}
			if ('DevID' == $Sort) {
				$Sort = 'DeviceID';
			}
			if (! in_array ( strtolower ( $Order ), array ('asc', 'desc' ) )) {
				$Order = 'DESC';
			}
			$sql .= " ORDER BY " . $Sort . " " . $Order;
			//			$sql .= " ORDER BY :SortName :SortOrder";
			//			$ParamArr[':SortName'] = $Sort;
			//			$ParamArr[':SortOrder'] = $Order;
			//			$sortArr [] = $Sort . ' ' . $Order;
			$SortFlag = true;
		}
		
		if (! $SortFlag) {
			//			$sortArr[] = 'DevLogID DESC';
			$sql .= " ORDER BY DevLogID DESC";
		
		//			$sql .= " ORDER BY :SortName :SortOrder";
		//			$ParamArr[':SortName'] = 'DevLogID';
		//			$ParamArr[':SortOrder'] = 'DESC';
		}
		$start = - 1;
		$size = - 1;
		
		$limitArr = array ();
		
		//分页数据
		if (isset ( $_POST ['page'] ) && isset ( $_POST ['rows'] ) && is_numeric ( $_POST ['page'] ) && is_numeric ( $_POST ['rows'] )) {
			$page = $_POST ['page'];
			$size = $_POST ['rows'];
			$start = ($page - 1) * $size;
		} else if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] ) && is_numeric ( $DataParam ['Start'] ) && is_numeric ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
		}
		
		if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
			//			$sql = $sql . " LIMIT :Start, :Size";
			//			$ParamArr[':Start'] = $start;
			//			$ParamArr[':Size'] = $size;
			$sql = $sql . " LIMIT " . $start . ", " . $size;
		
		//			$limitArr [] = $start;
		//			$limitArr [] = $size;
		}
		$result = DBMethodUtils::listData ( $sql, $ParamArr );
		$out = array ();
		
		if (! empty ( $result )) {
			foreach ( $result as $item ) {
				$EventDesc = '';
				switch ($item ['Event']) {
					case 1 : // 在线/离线
						$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_online' ) : $this->getStr ( "appcommon", 'log_online_offline' );
						break;
					case 2 : // 打开/关闭
						$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_pwr_on' ) : $this->getStr ( "appcommon", 'log_pwr_on_off' );
						break;
					case 3 : // 可用/不可用
						$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_enable' ) : $this->getStr ( "appcommon", 'log_enable_disable' );
						break;
					case 4 : // 投影机开/关
						$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_project_open' ) : $this->getStr ( "appcommon", 'log_projecter_open_close' );
						break;
					case 5 : // 紧急信息
						$EventDesc = $this->getStr ( "appcommon", 'log_emergency' );
						break;
					default :
						break;
				}
				$item ['Event'] = $EventDesc;
				//格式化时长
				if (! empty ( $item ["Duration"] )) {
					//小时
					$hour = intval ( $item ["Duration"] / (3600) );
					//分钟
					$minute = intval ( (($item ["Duration"]) % 3600) / 60 );
					//秒
					$second = $item ["Duration"] % 60;
					//					$minute = intval ( (($item ["Duration"] - $second) % 3600) / 60 );
					//					$hour = intval ( (($item ["Duration"] - $second - $minute * 60) % (3600 * 24)) / 3600 );
					//					$day = intval ( ($item ["Duration"] - $second - $minute * 60 - $hour * 3600) / (3600 * 24) );
					

					$item ["Duration"] = str_pad ( $hour, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $minute, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $second, 2, '0', STR_PAD_LEFT );
				}
				$out [] = $item;
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array ('Total' => $AllCount, 'Rows' => $out ) );
	}
	
	/**
	 * 加载设备能耗
	 */
	public function actionListDeviceEnergy() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		// 时间类型，1：小时，2：分钟，默认：1
		$TimeType = 1;
		
		if (isset ( $DataParam ['TimeType'] )) {
			$TimeType = $DataParam ['TimeType'];
		}
		if (! in_array ( $TimeType, array (1, 2 ) )) {
			$TimeType = 1;
		}
		$ParamArr = array ();
		$sql = ALogUtils::getListDeviceEnergySql ( $UserID, $DataParam, $ParamArr );
		
		$result = DBMethodUtils::listData ( $sql, $ParamArr );
		$arr = ALogUtils::dealPowerStatistic ( $result );
		$out = array ();
		
		//获取物联设备
		$RfDev = ExpandUtil::LoadExpandDev ();
		
		$tempTime = 3600;
		
		if ($TimeType == 2) {
			$tempTime = 60;
		}
		
		foreach ( $arr as $item ) {
			$newitem = array ();
			$newitem ['Dev_Name'] = $item ['Dev_Name']; // 设备名字
			$devPwr = array ();
			
			if (isset ( $item ['pwr'] )) {
				$devPwr = $item ['pwr'];
			}
			$devTime = array ();
			
			if (isset ( $item ['time'] )) {
				$devTime = $item ['time'];
			}
			$newitem ['Projecter_UseTime'] = floor ( (isset ( $devTime [1] ) ? $devTime [1] : 0) / $tempTime );
			$newitem ['Projecter_Pwr'] = round ( isset ( $devPwr [1] ) ? $devPwr [1] / 1000 : 0, 1 );
			
			foreach ( $RfDev as $ritem ) {
				
				$RfDevID = $ritem ['PwrID'];
				
				if ($RfDevID >= 2 && $RfDevID < 16) {
					$newitem ['UseTime_' . $ritem ['PwrID']] = floor ( (isset ( $devTime [$RfDevID] ) ? $devTime [$RfDevID] : 0) / $tempTime );
					$newitem ['Pwr_' . $ritem ['PwrID']] = round ( isset ( $devPwr [$RfDevID] ) ? $devPwr [$RfDevID] / 1000 : 0, 1 );
				}
			
		//				if ($RfDevID == 2) {
			//					$newitem ['UseTime_' . $ritem ['PwrID']] = floor ( (isset ( $devTime [4] ) ? $devTime [4] : 0) / $tempTime );
			//					$newitem ['Pwr_' . $ritem ['PwrID']] = round ( isset ( $devPwr [4] ) ? $devPwr [4] / 1000 : 0, 1 );
			//				} else if ($RfDevID == 3) {
			//					$newitem ['UseTime_' . $ritem ['PwrID']] = floor ( (isset ( $devTime [5] ) ? $devTime [5] : 0) / $tempTime );
			//					$newitem ['Pwr_' . $ritem ['PwrID']] = round ( isset ( $devPwr [5] ) ? $devPwr [5] / 1000 : 0, 1 );
			//				} else if (($RfDevID >= 4) && ($RfDevID < 16)) {
			//					$newitem ['UseTime_' . $ritem ['PwrID']] = floor ( (isset ( $devTime [$RfDevID * 2] ) ? $devTime [$RfDevID * 2] : 0) / $tempTime );
			//					$newitem ['Pwr_' . $ritem ['PwrID']] = round ( isset ( $devPwr [$RfDevID * 2] ) ? $devPwr [$RfDevID * 2] / 1000 : 0, 1 );
			//				}
			

			}
			$newitem ['TimeType'] = $TimeType;
			$out [] = $newitem;
		}
		//获取总数
		$AllCount = count ( $out );
		
		$start = - 1;
		$size = - 1;
		
		//分页数据
		if (isset ( $_POST ['page'] ) && isset ( $_POST ['rows'] ) && is_numeric ( $_POST ['page'] ) && is_numeric ( $_POST ['rows'] )) {
			$page = $_POST ['page'];
			$size = $_POST ['rows'];
			$start = ($page - 1) * $size;
		} else if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] ) && is_numeric ( $DataParam ['Start'] ) && is_numeric ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
		}
		
		if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
			$out = array_slice ( $out, $start, $size );
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array ('Total' => $AllCount, 'Rows' => $out ) );
	}
	
	/**
	 * 加载用户操作日志 
	 */
	public function actionListUserOptLog() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		// 日志开始时间,年月日；2015-12-24
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		// 日志结束时间,年月日；2015-12-24
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		
		if (is_null ( $endTime ) || is_null ( $beginTime ) || "" == trim ( $endTime ) || "" == trim ( $beginTime ) || $endTime < $beginTime) {
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_ENDTIME_MUSTBIG, '结束时间必须大于开始时间，请确认！', null );
			return;
		}
		$ParamArr = array ();
		$sql = ALogUtils::getListUserOptLogSql ( $UserID, $DataParam, $ParamArr );
		
		//获取总数
		$CountSql = "SELECT COUNT(*) c FROM (" . $sql . ") cc";
		$AllCount = 0;
		$AllCountData = DBMethodUtils::findData ( $CountSql, $ParamArr );
		
		if (! empty ( $AllCountData ['c'] )) {
			$AllCount = $AllCountData ['c'];
		}
		// 排序
		$SortFlag = false;
		$Sort = "";
		$Order = "";
		
		if (! empty ( $_POST ['sort'] ) && ! empty ( $_POST ['order'] )) {
			$Sort = $_POST ['sort'];
			$Order = $_POST ['order'];
		} else if (! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			$Sort = $DataParam ['SortName'];
			$Order = $DataParam ['SortOrder'];
		} else if (! empty ( $DataParam ['sort'] ) && ! empty ( $DataParam ['order'] )) {
			$Sort = $DataParam ['sort'];
			$Order = $DataParam ['order'];
		}
		
		if (! empty ( $Sort )) {
			//可排序的字段
			$SortCol = array ('DevID', 'Dev_Name', 'CtrlUser', 'User_Name', 'User_Desc', 'DateTime', 'EndTime', 'Event', 'MsgContext' );
			
			if (! in_array ( $Sort, $SortCol )) {
				if ('Duration' == $Sort) {
					$Sort = '(UNIX_TIMESTAMP(a.EndTime) - UNIX_TIMESTAMP(a.DateTime))';
				} else {
					$Sort = 'DevLogID';
				}
			}
			if ('DevID' == $Sort) {
				$Sort = 'DeviceID';
			}
			if (! in_array ( strtolower ( $Order ), array ('asc', 'desc' ) )) {
				$Order = 'DESC';
			}
			$sql .= " ORDER BY " . $Sort . " " . $Order;
			$SortFlag = true;
		}
		
		if (! $SortFlag) {
			$sql .= " ORDER BY DevLogID DESC";
		}
		
		$start = - 1;
		$size = - 1;
		
		//分页数据
		if (isset ( $_POST ['page'] ) && isset ( $_POST ['rows'] ) && is_numeric ( $_POST ['page'] ) && is_numeric ( $_POST ['rows'] )) {
			$page = $_POST ['page'];
			$size = $_POST ['rows'];
			$start = ($page - 1) * $size;
		} else if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] ) && is_numeric ( $DataParam ['Start'] ) && is_numeric ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
		}
		
		if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
			$sql = $sql . " LIMIT " . $start . "," . $size;
		}
		$result = DBMethodUtils::listData ( $sql, $ParamArr );
		$out = array ();
		
		if (! empty ( $result )) {
			foreach ( $result as $item ) {
				$EventDesc = '';
				switch ($item ['Event']) {
					case 1 : // 在线/离线
						$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_online' ) : $this->getStr ( "appcommon", 'log_online_offline' );
						break;
					case 2 : // 打开/关闭
						$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_pwr_on' ) : $this->getStr ( "appcommon", 'log_pwr_on_off' );
						break;
					case 3 : // 可用/不可用
						$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_enable' ) : $this->getStr ( "appcommon", 'log_enable_disable' );
						break;
					case 4 : // 投影机开/关
						$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_project_open' ) : $this->getStr ( "appcommon", 'log_projecter_open_close' );
						break;
					case 5 : // 紧急信息
						$EventDesc = $this->getStr ( "appcommon", 'log_emergency' );
						break;
					default :
						break;
				}
				$item ['Event'] = $EventDesc;
				//格式化时长
				if (! empty ( $item ["Duration"] )) {
					//秒
					//小时
					$hour = intval ( $item ["Duration"] / (3600) );
					//分钟
					$minute = intval ( (($item ["Duration"]) % 3600) / 60 );
					//秒
					$second = $item ["Duration"] % 60;
					
					//					$second = $item ["Duration"] % 60;
					//					$minute = (($item ["Duration"] - $second) % 3600) / 60;
					//					$hour = (($item ["Duration"] - $second - $minute * 60) % (3600 * 24)) / 3600;
					//					$day = ($item ["Duration"] - $second - $minute * 60 - $hour * 3600) / (3600 * 24);
					

					$item ["Duration"] = str_pad ( $hour, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $minute, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $second, 2, '0', STR_PAD_LEFT );
				}
				$out [] = $item;
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array ('Total' => $AllCount, 'Rows' => $out ) );
	}
	
	/**
	 * 导出设备日志
	 */
	public function actionExportDevLogs() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		// 日志开始时间
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		// 日志结束时间,年月日；2015-12-24
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		
		if (is_null ( $endTime ) || is_null ( $beginTime ) || "" == trim ( $endTime ) || "" == trim ( $beginTime ) || $endTime < $beginTime) {
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_ENDTIME_MUSTBIG, '结束时间必须大于开始时间，请确认！', null );
			return;
		}
		$ParamArr = array ();
		$sql = ALogUtils::getListDeviceLogSql ( $UserID, $DataParam, $ParamArr );
		
		if (! empty ( $sql )) {
			// 排序
			$SortFlag = false;
			
			if (! empty ( $_POST ['sort'] ) && ! empty ( $_POST ['order'] )) {
				$Sort = $_POST ['sort'];
				$Order = $_POST ['order'];
				//可排序的字段
				$SortCol = array ('DevID', 'Dev_Name', 'CtrlUser', 'User_Name', 'User_Desc', 'DateTime', 'EndTime', 'Event', 'MsgContext' );
				
				if (! in_array ( $Sort, $SortCol )) {
					if ('Duration' == $Sort) {
						$Sort = '(UNIX_TIMESTAMP(a.EndTime) - UNIX_TIMESTAMP(a.DateTime))';
					} else {
						$Sort = 'DevLogID';
					}
				}
				if (! in_array ( strtolower ( $Order ), array ('asc', 'desc' ) )) {
					$Order = 'DESC';
				}
				$sql .= " ORDER BY " . $Sort . " " . $Order;
				$SortFlag = true;
			}
			
			if (! $SortFlag) {
				$sql .= " ORDER BY DevLogID DESC";
			}
			$result = DBMethodUtils::listData ( $sql, $ParamArr );
		} else {
			$result = array ();
		}
		//开始是日期，结束日期,事件
		$outContent = $this->getStr ( "appcommon", 'log_date_begin' ) . ' : ' . date ( 'Y-m-d', strtotime ( $beginTime ) );
		$outContent .= ',' . $this->getStr ( "appcommon", 'log_date_end' ) . ' : ' . date ( 'Y-m-d', strtotime ( $endTime ) );
		$outContent = ToolUtil::charsetToGb2132 ( $outContent ) . "\n";
		
		// 表头的输出
		$line = $this->getStr ( "appcommon", "log_dev_id" );
		$line .= ',' . $this->getStr ( "appcommon", "log_dev_name" );
		$line .= ',' . $this->getStr ( "appcommon", "log_user" );
		$line .= ',' . $this->getStr ( "appcommon", "log_dev_beigin_time" );
		$line .= ',' . $this->getStr ( "appcommon", "log_dev_end_time" );
		$line .= ',' . $this->getStr ( "appcommon", "log_dev_duration" );
		$line .= ',' . $this->getStr ( "appcommon", "log_event" );
		$outContent .= ToolUtil::charsetToGb2132 ( $line ) . "\n";
		
		foreach ( $result as $item ) {
			$EventDesc = '';
			switch ($item ['Event']) {
				case 1 : // 在线/离线
					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_online' ) : $this->getStr ( "appcommon", 'log_online_offline' );
					break;
				case 2 : // 打开/关闭
					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_pwr_on' ) : $this->getStr ( "appcommon", 'log_pwr_on_off' );
					break;
				case 3 : // 可用/不可用
					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_enable' ) : $this->getStr ( "appcommon", 'log_enable_disable' );
					break;
				case 4 : // 投影机开/关
					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_project_open' ) : $this->getStr ( "appcommon", 'log_projecter_open_close' );
					break;
				case 5 : // 紧急信息
					$EventDesc = $this->getStr ( "appcommon", 'log_emergency' );
					break;
				default :
					break;
			}
			//格式化时长
			if (! empty ( $item ["Duration"] )) {
				//秒
				//小时
				$hour = intval ( $item ["Duration"] / (3600) );
				//分钟
				$minute = intval ( (($item ["Duration"]) % 3600) / 60 );
				//秒
				$second = $item ["Duration"] % 60;
				
				//				$second = $item ["Duration"] % 60;
				//				$minute = intval ( (($item ["Duration"] - $second) % 3600) / 60 );
				//				$hour = intval ( (($item ["Duration"] - $second - $minute * 60) % (3600 * 24)) / 3600 );
				//				$day = intval ( ($item ["Duration"] - $second - $minute * 60 - $hour * 3600) / (3600 * 24) );
				

				$item ["Duration"] = str_pad ( $hour, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $minute, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $second, 2, '0', STR_PAD_LEFT );
			}
			
			$line = $item ['DevID'];
			$line .= ',' . $item ['Dev_Name'];
			$line .= ',' . $item ['User_Desc'];
			$line .= ',' . $item ['DateTime'];
			$line .= ',' . $item ['EndTime'];
			$line .= ',' . $item ['Duration'];
			$line .= ',' . $EventDesc;
			$outContent .= ToolUtil::charsetToGb2132 ( $line ) . "\n";
		}
		
		$FileName = $this->getStr ( "appcommon", 'log_dev_log' ) . date ( "YmjHis" ) . '.csv';
		AToolUtils::exportCsv ( $FileName, $outContent );
	
		//		
	//		$objectPHPExcel = Yii::app ()->yexcel->createPhpExcel ();
	//		$objectPHPExcel->setActiveSheetIndex ( 0 );
	//		
	//		// 数据的取出
	//		$model = Yii::app ()->session ['printdata'];
	//		
	//		//开始是日期，结束日期,事件
	//		$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'A1', $this->getStr ( "appcommon", 'log_date_begin' ) . ' : ' . date ( 'Y-m-d', strtotime ( $beginTime ) ) );
	//		$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'B1', $this->getStr ( "appcommon", 'log_date_end' ) . ' : ' . date ( 'Y-m-d', strtotime ( $endTime ) ) );
	//		
	//		// 表头的输出
	//		$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'A2', $this->getStr ( "appcommon", "log_dev_id" ) );
	//		$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'B2', $this->getStr ( "appcommon", "log_dev_name" ) );
	//		$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'C2', $this->getStr ( "appcommon", "log_user" ) );
	//		$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'D2', $this->getStr ( "appcommon", "log_dev_beigin_time" ) );
	//		$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'E2', $this->getStr ( "appcommon", "log_dev_end_time" ) );
	//		$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'F2', $this->getStr ( "appcommon", "log_dev_duration" ) );
	//		$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'G2', $this->getStr ( "appcommon", "log_event" ) );
	//		
	//		$i = 3;
	//		foreach ( $result as $item ) {
	//			$EventDesc = '';
	//			switch ($item ['Event']) {
	//				case 1 : // 在线/离线
	//					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_online' ) : $this->getStr ( "appcommon", 'log_online_offline' );
	//					break;
	//				case 2 : // 打开/关闭
	//					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_pwr_on' ) : $this->getStr ( "appcommon", 'log_pwr_on_off' );
	//					break;
	//				case 3 : // 可用/不可用
	//					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_enable' ) : $this->getStr ( "appcommon", 'log_enable_disable' );
	//					break;
	//				case 4 : // 投影机开/关
	//					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_project_open' ) : $this->getStr ( "appcommon", 'log_projecter_open_close' );
	//					break;
	//				case 5 : // 紧急信息
	//					$EventDesc = $this->getStr ( "appcommon", 'log_emergency' );
	//					break;
	//				default :
	//					break;
	//			}
	//			//格式化时长
	//			if (! empty ( $item ["Duration"] )) {
	//				//秒
	//				$second = $item ["Duration"] % 60;
	//				$minute = intval ( (($item ["Duration"] - $second) % 3600) / 60 );
	//				$hour = intval ( (($item ["Duration"] - $second - $minute * 60) % (3600 * 24)) / 3600 );
	//				$day = intval ( ($item ["Duration"] - $second - $minute * 60 - $hour * 3600) / (3600 * 24) );
	//				
	//				$item ["Duration"] = ($day > 0 ? $day . '.' : '') . str_pad ( $hour, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $minute, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $second, 2, '0', STR_PAD_LEFT );
	//			}
	//			
	//			$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'A' . $i, $item ['DevID'] );
	//			$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'B' . $i, $item ['Dev_Name'] );
	//			$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'C' . $i, $item ['User_Desc'] );
	//			$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'D' . $i, $item ['DateTime'] );
	//			$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'E' . $i, $item ['EndTime'] );
	//			$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'F' . $i, $item ['Duration'] );
	//			$objectPHPExcel->setActiveSheetIndex ( 0 )->setCellValue ( 'G' . $i, $EventDesc );
	//			$i ++;
	//		}
	//		ob_end_clean ();
	//		ob_start ();
	//		
	//		header ( 'Content-Type : application/vnd.ms-excel' );
	//		header ( 'Content-Disposition:attachment;filename="' . $this->getStr ( "appcommon", 'log_dev_log' ) . date ( "YmjHis" ) . '.xls"' );
	//		$objWriter = PHPExcel_IOFactory::createWriter ( $objectPHPExcel, 'Excel5' );
	//		$objWriter->save ( 'php://output' );
	}
	
	/**
	 * 导出设备能耗
	 */
	public function actionExportDeviceEnergy() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		// 时间类型，1：小时，2：分钟，默认：1
		$TimeType = 1;
		
		if (isset ( $DataParam ['TimeType'] )) {
			$TimeType = $DataParam ['TimeType'];
		}
		if (! in_array ( $TimeType, array (1, 2 ) )) {
			$TimeType = 1;
		}
		// 日志开始时间
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		// 日志结束时间
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		$ParamArr = array ();
		$sql = ALogUtils::getListDeviceEnergySql ( $UserID, $DataParam, $ParamArr );
		
		$result = DBMethodUtils::listData ( $sql, $ParamArr );
		$arr = ALogUtils::dealPowerStatistic ( $result );
		$out = array ();
		
		//获取物联设备
		$RfDev = ExpandUtil::LoadExpandDev ();
		
		$tempTime = 3600;
		
		if ($TimeType == 2) {
			$tempTime = 60;
		}
		//导出到excel
		$objectPHPExcel = Yii::app ()->yexcel->createPhpExcel ();
		$objectPHPExcel->setActiveSheetIndex ( 0 );
		// 数据的取出
		$model = Yii::app ()->session ['printdata'];
		
		$unit = $this->getStr ( "appcommon", 'log_duration_hour' );
		
		if ($TimeType == 2) {
			$unit = $this->getStr ( "appcommon", 'log_duration_minutes' );
		}
		$outContent = $this->getStr ( "appcommon", 'log_date_begin' ) . ' : ' . date ( 'Y-m-d', strtotime ( $beginTime ) );
		$outContent .= ',' . $this->getStr ( "appcommon", 'log_date_end' ) . ' : ' . date ( 'Y-m-d', strtotime ( $endTime ) );
		$outContent .= ',' . ($this->getStr ( "appcommon", 'log_duration_unit' ) . ' : ' . $unit);
		$outContent = ToolUtil::charsetToGb2132 ( $outContent ) . "\n";
		
		//表头
		$line = $this->getStr ( "appcommon", 'log_dev' );
		$line .= ',' . $this->getStr ( "appcommon", 'log_projector' ) . $this->getStr ( "appcommon", 'log_duration' );
		$line .= ',' . $this->getStr ( "appcommon", 'log_projector' ) . $this->getStr ( "appcommon", 'log_energy_usage' );
		
		foreach ( $RfDev as $item ) {
			$line .= ',' . $item ['Name'] . $this->getStr ( "appcommon", 'log_duration' );
			$line .= ',' . $item ['Name'] . $this->getStr ( "appcommon", 'log_energy_usage' );
		}
		$outContent .= ToolUtil::charsetToGb2132 ( $line ) . "\n";
		
		//导出数据
		foreach ( $arr as $item ) {
			$newitem = array ();
			$Dev_Name = $item ['Dev_Name']; // 设备名字
			$devPwr = array ();
			
			if (isset ( $item ['pwr'] )) {
				$devPwr = $item ['pwr'];
			}
			$devTime = array ();
			
			if (isset ( $item ['time'] )) {
				$devTime = $item ['time'];
			}
			$Projecter_UseTime = floor ( (isset ( $devTime [1] ) ? $devTime [1] : 0) / $tempTime );
			$Projecter_Pwr = round ( isset ( $devPwr [1] ) ? $devPwr [1] / 1000 : 0, 1 );
			
			$line = $Dev_Name;
			$line .= ',' . $Projecter_UseTime . ($TimeType == 2 ? "m" : "h");
			$line .= ',' . $Projecter_Pwr . "kw/h";
			
			foreach ( $RfDev as $ritem ) {
				$RfDevID = $ritem ['PwrID'];
				$UseTime = 0;
				$Pwr = 0;
				
				if ($RfDevID >= 2 && $RfDevID < 16) {
					$UseTime = floor ( (isset ( $devTime [$RfDevID] ) ? $devTime [$RfDevID] : 0) / $tempTime );
					$Pwr = round ( isset ( $devPwr [$RfDevID] ) ? $devPwr [$RfDevID] / 1000 : 0, 1 );
				}
				$line .= ',' . $UseTime . ($TimeType == 2 ? "m" : "h");
				$line .= ',' . $Pwr . "kw/h";
			}
			$outContent .= ToolUtil::charsetToGb2132 ( $line ) . "\n";
		}
		
		$FileName = $this->getStr ( "appcommon", 'log_dev_energy_usage_log' ) . date ( "YmjHis" ) . '.csv';
		AToolUtils::exportCsv ( $FileName, $outContent );
	}
	
	/**
	 * 导出用户操作日志
	 */
	public function actionExportUserLogs() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		// 日志开始时间,年月日；2015-12-24
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		// 日志结束时间,年月日；2015-12-24
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		
		if (is_null ( $endTime ) || is_null ( $beginTime ) || "" == trim ( $endTime ) || "" == trim ( $beginTime ) || $endTime < $beginTime) {
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_ENDTIME_MUSTBIG, '结束时间必须大于开始时间，请确认！', null );
			return;
		}
		$ParamArr = array ();
		$sql = ALogUtils::getListUserOptLogSql ( $UserID, $DataParam, $ParamArr );
		// 排序
		$SortFlag = false;
		
		if (! empty ( $_POST ['sort'] ) && ! empty ( $_POST ['order'] )) {
			$Sort = $_POST ['sort'];
			$Order = $_POST ['order'];
			//可排序的字段
			$SortCol = array ('DevID', 'Dev_Name', 'CtrlUser', 'User_Name', 'User_Desc', 'DateTime', 'EndTime', 'Event', 'MsgContext' );
			
			if (! in_array ( $Sort, $SortCol )) {
				if ('Duration' == $Sort) {
					$Sort = '(UNIX_TIMESTAMP(a.EndTime) - UNIX_TIMESTAMP(a.DateTime))';
				} else {
					$Sort = 'DevLogID';
				}
			}
			if (! in_array ( strtolower ( $Order ), array ('asc', 'desc' ) )) {
				$Order = 'DESC';
			}
			$sql .= " ORDER BY " . $Sort . " " . $Order;
			$SortFlag = true;
		}
		$result = DBMethodUtils::listData ( $sql, $ParamArr );
		
		$outContent = $this->getStr ( "appcommon", 'log_date_begin' ) . ' : ' . date ( 'Y-m-d', strtotime ( $beginTime ) );
		$outContent .= ',' . $this->getStr ( "appcommon", 'log_date_end' ) . ' : ' . date ( 'Y-m-d', strtotime ( $endTime ) );
		$outContent = ToolUtil::charsetToGb2132 ( $outContent ) . "\n";
		
		// 表头的输出
		$line = $this->getStr ( "appcommon", "log_dev_id" );
		$line .= ',' . $this->getStr ( "appcommon", "log_dev_name" );
		$line .= ',' . $this->getStr ( "appcommon", "log_user" );
		$line .= ',' . $this->getStr ( "appcommon", "log_dev_beigin_time" );
		$line .= ',' . $this->getStr ( "appcommon", "log_dev_end_time" );
		$line .= ',' . $this->getStr ( "appcommon", "log_dev_duration" );
		$line .= ',' . $this->getStr ( "appcommon", "log_event" );
		$line .= ',' . $this->getStr ( "appcommon", "log_remarks" );
		$outContent .= ToolUtil::charsetToGb2132 ( $line ) . "\n";
		
		foreach ( $result as $item ) {
			$EventDesc = '';
			switch ($item ['Event']) {
				case 1 : // 在线/离线
					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_online' ) : $this->getStr ( "appcommon", 'log_online_offline' );
					break;
				case 2 : // 打开/关闭
					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_pwr_on' ) : $this->getStr ( "appcommon", 'log_pwr_on_off' );
					break;
				case 3 : // 可用/不可用
					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_enable' ) : $this->getStr ( "appcommon", 'log_enable_disable' );
					break;
				case 4 : // 投影机开/关
					$EventDesc = empty ( $item ['EndTime'] ) ? $this->getStr ( "appcommon", 'log_project_open' ) : $this->getStr ( "appcommon", 'log_projecter_open_close' );
					break;
				case 5 : // 紧急信息
					$EventDesc = $this->getStr ( "appcommon", 'log_emergency' );
					break;
				default :
					break;
			}
			$item ['Event'] = $EventDesc;
			//格式化时长
			if (! empty ( $item ["Duration"] )) {
				//小时
				$hour = intval ( $item ["Duration"] / (3600) );
				//分钟
				$minute = intval ( (($item ["Duration"]) % 3600) / 60 );
				//秒
				$second = $item ["Duration"] % 60;
				//				//秒
				//				$second = $item ["Duration"] % 60;
				//				$minute = (($item ["Duration"] - $second) % 3600) / 60;
				//				$hour = (($item ["Duration"] - $second - $minute * 60) % (3600 * 24)) / 3600;
				//				$day = ($item ["Duration"] - $second - $minute * 60 - $hour * 3600) / (3600 * 24);
				

				$item ["Duration"] = str_pad ( $hour, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $minute, 2, '0', STR_PAD_LEFT ) . ':' . str_pad ( $second, 2, '0', STR_PAD_LEFT );
			}
			
			$line = $item ['DevID'];
			$line .= ',' . $item ['Dev_Name'];
			$line .= ',' . $item ['User_Desc'];
			$line .= ',' . $item ['DateTime'];
			$line .= ',' . $item ['EndTime'];
			$line .= ',' . $item ['Duration'];
			$line .= ',' . $EventDesc;
			$line .= ',' . $item ['MsgContext'];
			$outContent .= ToolUtil::charsetToGb2132 ( $line ) . "\n";
		}
		$FileName = $this->getStr ( "appcommon", 'log_user_opt_log' ) . date ( "YmjHis" ) . '.csv';
		AToolUtils::exportCsv ( $FileName, $outContent );
	}
	
	/**
	 * 清除设备日志
	 */
	public function actionClearDevLogs() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		// 日志开始时间
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		// 日志结束时间,年月日；2015-12-24
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		
		if (is_null ( $endTime ) || is_null ( $beginTime ) || "" == trim ( $endTime ) || "" == trim ( $beginTime ) || $endTime < $beginTime) {
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_ENDTIME_MUSTBIG, '结束时间必须大于开始时间，请确认！', null );
			return;
		}
		// 需要查询日志的设备ID，格式：1，2，3；查询全部日志则不传递参数
		$deviceID = "";
		
		if (isset ( $DataParam ['DeviceIDs'] )) {
			$deviceID = $DataParam ['DeviceIDs'];
		}
		$beginTime = date ( 'Y-m-d', strtotime ( $beginTime ) ) . ' 00:00:00';
		$endTime = date ( 'Y-m-d', strtotime ( $endTime ) ) . ' 23:59:59';
		
		// 日志类型，格式：1，2，3；全部则不用传值
		$Event = '';
		
		if (! empty ( $DataParam ['Event'] )) {
			$Event = $DataParam ['Event'];
		}
		
		if (empty ( $Event )) {
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', null );
			return;
		}
		$ParamArr = array ();
		$sql = "DELETE FROM DeviceLog";
		$sql .= " WHERE DateTime >=:beginTime AND DateTime<= :endTime";
		$ParamArr [':beginTime'] = $beginTime;
		$ParamArr [':endTime'] = $endTime;
		
		if (! is_null ( $UserID ) && $UserID > 0) {
			$sql .= DeviceUtil::GetUserCtrDevSql ( " AND DeviceID ", $UserID );
		}
		//设备id
		if (! empty ( $deviceID )) {
			$sql .= " AND DeviceID IN(" . $deviceID . ")";
		}
		//事件
		if (! empty ( $Event )) {
			$arr = explode ( ",", $Event );
			$tempArr = array ();
			
			foreach ( $arr as $item ) {
				if (is_numeric ( $item )) {
					$tempArr [] = $item;
				}
			}
			if (empty ( $tempArr )) {
				return "";
			}
			$sql = $sql . " AND Event IN(" . implode ( ",", $tempArr ) . ")";
		} else {
			$sql = $sql . " AND 0";
		}
		
		//搜索
		if (! empty ( $DataParam ['searchKey'] )) {
			$searchKey = $DataParam ['searchKey'];
			$sql .= " AND (DeviceID IN(SELECT DevID FROM DeviceList WHERE DevID LIKE CONCAT('%', :searchKey, '%') OR Dev_Name LIKE CONCAT('%', :searchKey1, '%'))";
			$sql .= " OR CtrlUser IN(SELECT User_ID FROM Users WHERE User_Desc LIKE CONCAT('%', :searchKey2, '%')))";
			
			$ParamArr [':searchKey'] = $searchKey;
			$ParamArr [':searchKey1'] = $searchKey;
			$ParamArr [':searchKey2'] = $searchKey;
		}
		DBMethodUtils::RunSql ( $sql, $ParamArr );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', null );
	}
	
	/**
	 * 清除设备能耗
	 */
	public function actionClearDeviceEnergy() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		// 时间类型，1：小时，2：分钟，默认：1
		$TimeType = 1;
		
		if (isset ( $DataParam ['TimeType'] )) {
			$TimeType = $DataParam ['TimeType'];
		}
		if (! in_array ( $TimeType, array (1, 2 ) )) {
			$TimeType = 1;
		}
		// 日志开始时间
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		// 日志结束时间
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		// 需要查询日志的设备ID，格式：1，2，3；查询全部日志则不传递参数
		$deviceID = "";
		
		if (isset ( $DataParam ['DeviceIDs'] )) {
			$deviceID = $DataParam ['DeviceIDs'];
		}
		$beginTime = date ( 'Y-m-d', strtotime ( $beginTime ) ) . ' 00:00:00';
		$endTime = date ( 'Y-m-d', strtotime ( $endTime ) ) . ' 23:59:59';
		
		$sql = "DELETE FROM  DeviceStatistic";
		$sql .= " WHERE sp_dev_belong_group(DeviceID , 0) = true and StatisticDay >= '" . $beginTime . "' and StatisticDay < '" . $endTime . "'";
		
		if (! is_null ( $UserID ) && $UserID > 0) {
			$sql .= DeviceUtil::GetUserCtrDevSql ( " AND DeviceID ", $UserID );
		}
		
		if (! empty ( $deviceID )) {
			$sql .= " AND a.DeviceID IN(" . $deviceID . ")";
		}
		
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', null );
	}
	
	/**
	 * 清除用户操作日志
	 */
	public function actionClearUserLogs() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		// 日志开始时间,年月日；2015-12-24
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		// 日志结束时间,年月日；2015-12-24
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		
		if (is_null ( $endTime ) || is_null ( $beginTime ) || "" == trim ( $endTime ) || "" == trim ( $beginTime ) || $endTime < $beginTime) {
			echo $this->PackResponseData ( ErrcodeUtil::$DEVICE_ENDTIME_MUSTBIG, '结束时间必须大于开始时间，请确认！', null );
			return;
		}
		
		// 需要查询日志的设备ID，格式：1，2，3；查询全部日志则不传递参数
		$deviceID = "";
		
		if (isset ( $DataParam ['DeviceIDs'] )) {
			$deviceID = $DataParam ['DeviceIDs'];
		}
		$beginTime = date ( 'Y-m-d', strtotime ( $beginTime ) ) . ' 00:00:00';
		$endTime = date ( 'Y-m-d', strtotime ( $endTime ) ) . ' 23:59:59';
		
		//操作用户id
		$CtrlUser = null;
		
		if (isset ( $DataParam ['CtrlUser'] )) {
			$CtrlUser = $DataParam ['CtrlUser'];
		}
		$ParamArr = array ();
		$sql = "DELETE FROM DeviceLog";
		$sql .= " WHERE DateTime >=:beginTime AND DateTime<= :endTime";
		$ParamArr [':beginTime'] = $beginTime;
		$ParamArr [':endTime'] = $endTime;
		
		//		$sql .= ' WHERE CtrlUser >= 0 AND DateTime >="' . $beginTime . '" AND DateTime<= "' . $endTime . '"';
		

		//用户id
		if (! empty ( $CtrlUser ) && $CtrlUser > 0) {
			$sql .= ' AND CtrlUser = :CtrlUser';
			$ParamArr [':CtrlUser'] = $CtrlUser;
		}
		
		//搜索
		if (! empty ( $DataParam ['searchKey'] )) {
			$searchKey = $DataParam ['searchKey'];
			$sql .= " AND (DeviceID IN(SELECT DevID FROM DeviceList WHERE DevID LIKE CONCAT('%', :searchKey, '%') OR Dev_Name LIKE CONCAT('%', :searchKey1, '%'))";
			$sql .= " OR CtrlUser IN(SELECT User_ID FROM Users WHERE User_Desc LIKE CONCAT('%', :searchKey2, '%')))";
			
			$ParamArr [':searchKey'] = $searchKey;
			$ParamArr [':searchKey1'] = $searchKey;
			$ParamArr [':searchKey2'] = $searchKey;
		}
		DBMethodUtils::RunSql ( $sql, $ParamArr );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', null );
	}
/*********************************************************************************/
}