<?php
class UpdateController extends WebAdminBaseController {
	
	/**
	 * 获取设备状态
	 * @param $UserID
	 * @param $DeviceID
	 * @param $expandSource
	 * @param $expandMode
	 */
	public function LoadDevicestatus($UserID, $DeviceID, $expandSource, $expandMode) {
		
		//		$sql = 'select a.DevID,a.Dev_Name,a.Dev_Description,b.*, c.StreamType, f.User_Desc
		//			FROM DeviceList a 
		//			LEFT JOIN DeviceStatus b on a.DevID = b.DeviceID 
		//			LEFT JOIN PlaySessions c on c.SessionID=b.ActualSessionID 
		//			LEFT JOIN BroadcastMode d on d.idBroadcastMode = get_dev_mode(a.DevID) 
		//			LEFT JOIN DeviceDesiredStaus e on e.DeviceID = a.DevID 
		//			LEFT JOIN Users f ON b.User_ID = f.User_ID';
		//		
		//
		//		if ($UserID > 0) {
		//			$sql .= ' RIGHT JOIN UserDevices g ON g.UserID = ' . $UserID . ' AND g.Pri & ' . SystemUtil::getUserDevMask ( "1" ) . ' > 0 AND a.DevID = g.DevID ';
		//		}
		

		$sql = 'SELECT a.DevID,a.Dev_Name,a.Dev_Description,b.*,e.SessionID,IF(ISNULL(cc.SessionID), "", c.SessionName) AS SessionName, d.ModeName, a.Parent, c.StreamType, f.User_Desc
			FROM DeviceList a 
			LEFT JOIN DeviceStatus b on a.DevID = b.DeviceID 
			LEFT JOIN PlaySessions c on c.SessionID=b.ActualSessionID 
			LEFT JOIN PlayingSessions cc ON cc.SessionID=b.ActualSessionID 
			left join DeviceDesiredStaus e on e.DeviceID = a.DevID 
			LEFT JOIN BroadcastMode d on d.idBroadcastMode = e.BrdMode 
			LEFT JOIN Users f ON b.User_ID = f.User_ID
			WHERE sp_dev_belong_group( a.DevID , 0) = true';
		
		$where = array ();
		
		if (! is_null ( $UserID ) && $UserID > 0) {
			$where [] = DeviceUtil::GetUserCtrDevSql ( " a.DevID ", $UserID );
		}
		$where [] = ' a.DevID = "' . $DeviceID . '"';
		
		if (! empty ( $where )) {
			$sql .= ' AND ' . implode ( ' AND ', $where );
		}
		$DeviceStatus = DBMethodUtils::findData ( $sql );
		
		if (! is_null ( $DeviceStatus ) && isset ( $DeviceStatus ['DevID'] )) {
			$item = DeviceUtil::PackDevice ( $DeviceStatus, $expandSource, $expandMode );
			
			if (! empty ( $item ) && ! empty ( $DeviceStatus )) {
				$SteamTypeUp = round ( $DeviceStatus ['StreamType'] / 128 );
				$item ['SteamTypeUp'] = $SteamTypeUp == 1 ? 1 : 0;
			}
			return $item;
		}
		
		return null;
	}
	
	/**
	 * 获取任务状态
	 * @param $UserID 用户ID
	 * @param $SessionID 任务ID
	 * @param $ScheduleID 任务执行时间ID
	 */
	public function LoadSessionstatus($UserID, $SessionID, $ScheduleID) {
		
		$sql = "SELECT CONCAT(a.SessionID, '_', a.ScheduleID) AS TempId, a.SessionID, a.ScheduleID, DATE_FORMAT(a.PlayTime,'%H:%i:%S') as PlayTime, b.CircleLength, a.TempFlag,
			IF(" . (is_null ( $UserID ) ? 0 : $UserID) . " <= 0, IF((ISNULL(uu.User_Name) OR LENGTH(uu.User_Name) < 1), b.SessionName, CONCAT(uu.User_Name, ':',b.SessionName)), b.SessionName) SessionName
			, b.SessionType, b.Priority, b.StreamType, b.SysEnabled, b.RfDevCtrl, dd.Pause,mf.FileName, IF(ISNULL(pl.PlayListCount), 0, pl.PlayListCount) AS PlayListCount 
			FROM PlaySessionTime a LEFT JOIN PlaySessions b ON a.SessionID=b.SessionID 
			LEFT JOIN PlayingSessions dd ON a.SessionID=dd.SessionID AND a.ScheduleID=dd.ScheduleID LEFT JOIN PlayingSessions ps ON a.SessionID=ps.SessionID 
			LEFT JOIN MediaFiles mf ON ps.PlayingFileID=mf.MediaID LEFT JOIN Users uu ON b.Owner=uu.User_ID
			LEFT JOIN (SELECT COUNT(*) AS PlayListCount, SessionID FROM PlayListFiles GROUP BY SessionID) pl ON a.SessionID=pl.SessionID
			WHERE a.ScheduleID = '" . $ScheduleID . "'";
		
		$OwnerWhere = array ();
		
		if (! is_null ( $UserID ) && $UserID > 0) { //普通用户，只获取自己的任务
			$OwnerWhere [] = " b.Owner = '" . $UserID . "'";
		}
		if (! empty ( $OwnerWhere )) {
			$sql .= ' AND (' . implode ( ' OR ', $OwnerWhere ) . ')';
		}
		
		$Session = DBMethodUtils::findData ( $sql );
		$newitem = ATaskUtil::packTaskListByWeekday ( $Session );
		
		return $newitem;
	}
	
	/**
	 * 获取手动任务的状态
	 * @param  $UserID
	 * @param  $SessionID
	 */
	public function LoadHandSessionstatus($UserID, $SessionID) {
		
		if (! is_null ( $UserID ) && $UserID != 0) {
			return null;
		}
		$sql = "SELECT a.SessionID AS TempId, a.SessionID, a.SessionName, a.SessionType, a.Priority, a.CircleLength, a.StreamType, c.FileName, 
				b.CurrFileProgress, b.CurrTotalProgress, dd.Pause, IF(ISNULL(pl.PlayListCount), 0, pl.PlayListCount) AS PlayListCount
		     	FROM PlaySessions a LEFT JOIN PlayingSessions b ON a.SessionID=b.SessionID LEFT JOIN MediaFiles c ON b.PlayingFileID=c.MediaID
			 	LEFT JOIN PlayingSessions dd ON a.SessionID=dd.SessionID 
			 	LEFT JOIN (SELECT COUNT(*) AS PlayListCount, SessionID FROM PlayListFiles GROUP BY SessionID) pl ON a.SessionID=pl.SessionID WHERE a.SessionType IN(2,9) 
			 	AND a.SessionID = '" . $SessionID . "'";
		$newitem = DBMethodUtils::findData ( $sql );
		
		if (! empty ( $newitem )) {
			$newitem ['SteamTypeDown'] = $newitem ['StreamType'] - round ( $newitem ['StreamType'] / 128 ) * 128;
		}
		
		return $newitem;
	}
	
	/**
	 * 获取实时采播
	 * @param  $UserID
	 * @param  $SessionID
	 */
	public function LoadRealtimeSession($UserID, $PlayerID, $SessionID) {
		
		$sql = 'SELECT * FROM (SELECT a.SessionID AS TempId, a.SessionID, IF(ISNULL(e.User_Desc), a.SessionName, e.User_Desc) AS SessionName, 
				a.Priority, a.Status, a.CircleLength, b.Pause, 
				c.IpAddress, 
				d.PlayerType,
				a.PlayerID
				FROM PlaySessions a 
				LEFT JOIN PlayingSessions b on  b.SessionID = a.SessionID 
				LEFT JOIN PlayerStatus c on c.PlayerID = a.PlayerID 
				LEFT JOIN Players d on d.PlayerID = a.PlayerID 
				LEFT JOIN Users e on a.Owner = e.User_ID 
				LEFT JOIN PlayListFiles f on f.SessionID = a.SessionID and f.SequenceID = 0 
				WHERE (a.Parent is null or (Parent = 0)) and (a.SessionType = 1 or a.SessionType = 10)) aa WHERE ';
		if(isset($SessionID) && is_numeric($SessionID))
		    $sql .= 'SessionID = ' . $SessionID;
		else
            $sql .= 'PlayerID = ' . $PlayerID;
		$data = DBMethodUtils::findData ( $sql );
		
		return $data;
	}
	
	/**
	 * 获取模式状态
	 * @param unknown_type $UserID
	 * @param unknown_type $ModeId
	 */
	public function LoadMode($UserID, $ModeId) {
		
		if (! is_null ( $UserID ) && $UserID != 0) {
			return null;
		}
		//加载模式
		$Mode = BroadcastMode::model ()->findByPk ( $ModeId );
		
		if (empty ( $Mode )) {
			return null;
		}
		$res = array ();
		$res ['SecondType'] = $Mode->idBroadcastMode;
		$res ['Name'] = $Mode->ModeName;
		$res ['Active'] = $Mode->Active;
		
		if ($Mode->Enabled == 1) { //运行模式
			$res ['Type'] = ATaskUtil::MENU_TYPE_TASK_MODE_RUN;
		} else { //备用模式
			$res ['Type'] = ATaskUtil::MENU_TYPE_TASK_MODE_STOPED;
		}
		
		return $res;
	}
	
	/**
	 * 更新信息
	 */
	public function actionLoadUpdateInfo() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (is_null ( $UserID )) {
			$UserID = 0;
		}
		//最后一条消息的ID
		$LastID = $this->GetDataParam ( $DataParam, 'LastID', 0, true );
		$sql = 'SELECT * FROM (SELECT ID,MsgFrom, MsgType, MsgTime, CmdType, CmdObjType, CmdObjID, CmdObjIP FROM Messages WHERE (ID >' . $LastID . ') AND (MsgTo = 2) ORDER BY ID DESC) a GROUP BY MsgType, CmdType, CmdObjID';
		$MsgList = DBMethodUtils::listData ( $sql );
		
		$Devices = array ();
		$Tasks = array ();
		$HandTask = array ();
		$RealtimeTask = array ();
		$TaskNeedRefresh = 0;
		$Menu = array ();
		
		if (! is_null ( $MsgList ) && count ( $MsgList ) > 0) {
			//查询扩展电源信息
			$expandSource = null;
			//加载扩展电源的模式
			$expandMode = null;
			
			foreach ( $MsgList as $item ) {
				if ($item ['ID'] > $LastID) {
					$LastID = $item ['ID'];
				}
				$DeviceID = $item ['CmdObjID'];
				
				switch ($item ['MsgType']) {
					case 3 : //设备，任务（定时、模板、模式）
						///////////////////////////////////////////////////////////
						if (is_null ( $expandSource ) || is_null ( $expandMode )) {
							$expandSource = ExpandUtil::LoadExpandDev ();
							$expandMode = ExpandUtil::LoadExpandMode ();
						}
						$DeviceStatus = $this->LoadDevicestatus ( $UserID, $DeviceID, $expandSource, $expandMode );
						
						if (! empty ( $DeviceStatus )) {
							$Devices [] = $DeviceStatus;
						}
						///////////////////////////////////////////////////////////
						//						if (DeviceUtil::GetDevType ( $DeviceID ) == DeviceUtil::DEV_TYPE_PC_CALLER || DeviceUtil::GetDevType ( $DeviceID ) == DeviceUtil::DEV_TYPE_EMBEDED_CALLER) {
						$tempdata = $this->LoadRealtimeSession ( $UserID, $item ['CmdObjID'] , null);
						
						if (! empty ( $tempdata )) {
							$RealtimeTask [] = $tempdata;
						}
						//						}
						break;
					case 10 : //任务（需要更新任务状态，是否临时，播出状态）
						if ($item ['CmdType'] == 0) {
							$TaskNeedRefresh = 1;
						}
						$tempdata = $this->LoadSessionstatus ( $UserID, $item ['CmdType'], $item ['CmdObjType'] );
						
						if (! empty ( $tempdata )) {
							$Tasks [] = $tempdata;
						}
						$tempdata = $this->LoadHandSessionstatus ( $UserID, $item ['CmdType'] );
						
						if (! empty ( $tempdata )) {
							$HandTask [] = $tempdata;
						}
						$tempdata = $this->LoadRealtimeSession ( $UserID, null, $item['CmdType'] );
						
						if (! empty ( $tempdata )) {
							$RealtimeTask [] = $tempdata;
						}
						break;
					case 9 : //任务（定时、模板、模式）
						$tempdata = $this->LoadSessionstatus ( $UserID, $item ['CmdType'], $item ['CmdObjType'] );
						
						if (! empty ( $tempdata )) {
							$Tasks [] = $tempdata;
						}
						$tempdata = $this->LoadHandSessionstatus ( $UserID, $item ['CmdType'] );
						
						if (! empty ( $tempdata )) {
							$HandTask [] = $tempdata;
						}
						$tempdata = $this->LoadRealtimeSession ( $UserID, $item ['CmdObjID'], null);
						
						if (! empty ( $tempdata )) {
							$RealtimeTask [] = $tempdata;
						}
						break;
					case 12 : //导航树
						$Mode = $this->LoadMode ( $UserID, $item ['CmdObjType'] );
						
						if (! empty ( $Mode )) {
							$Menu [] = $Mode;
						}
						break;
					default :
						break;
				}
			}
		}
		$res = array ('LastID' => $LastID, 'RefreshTime' => '5', 'Devices' => $Devices, 'Tasks' => $Tasks, 'HandTask' => $HandTask, 'RealtimeTask' => $RealtimeTask, 'TaskNeedRefresh' => $TaskNeedRefresh, 'Menu' => $Menu );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $res );
	}

    //控制台关闭窗口
    public function actionIpcallClose(){
		$UserID = $this->GetPostOwnerID ();
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
        if(is_null($UserID))
            $UserID = 0;

		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );

		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$id = $DataParam['id'];
        if(is_null($id) || !is_numeric($id)){
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
        }
        //只能挂断自己的呼叫或者未接听的指定呼叫
        $sql = "update IpCall set IpCall.status='idle' where IpCall.id=$id;";
        $fp = fopen('call.log', 'a');
        fwrite($fp, $sql . "\n");
        fclose($fp);
        DBMethodUtils::runSql($sql);
        // 更新CallWaiter 表
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array());
    }

    //控制台挂机
    public function actionIpcallOnhook(){
		$UserID = $this->GetPostOwnerID ();
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
        if(is_null($UserID))
            $UserID = 0;

		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );

		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$id = $DataParam['id'];
        if(is_null($id) || !is_numeric($id)){
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
        }
        //只能挂断自己的呼叫或者未接听的指定呼叫
        $sql = "update IpCall,CallWaiter set IpCall.status='idle' where CallWaiter.session='" . $_POST['Session'] . "' and CallWaiter.user=$UserID ";
        $sql.= "and IpCall.id=$id and (IpCall.waiter is null or IpCall.waiter = CallWaiter.id);";
        DBMethodUtils::runSql($sql);
        // 更新CallWaiter 表
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array());
    }
    //控制台接听
    public function actionIpcallAccept(){
		$UserID = $this->GetPostOwnerID ();
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
        if(is_null($UserID))
            $UserID = 0;

		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );

		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$id = $DataParam['id'];
        if(is_null($id) || !is_numeric($id)){
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
        }
        //尝试以当前用户的waiterid填写呼叫记录
        $sql = "update IpCall,CallWaiter set IpCall.waiter=CallWaiter.id where CallWaiter.session='" . $_POST['Session'] . "' and CallWaiter.user=$UserID ";
        $sql.= "and IpCall.id=$id and IpCall.waiter is null;";
        DBMethodUtils::runSql($sql);
        // 更新CallWaiter 表
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array());
    }
    //控制台心跳和监听
    public function actionIpcallListen(){
		$UserID = $this->GetPostOwnerID ();
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
        if(is_null($UserID))
            $UserID = 0;
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );

		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
        $status = $DataParam['status'];
		$id = $DataParam['id'];
        if(is_null($id) || !is_numeric($id) || is_null($status) || !is_numeric($status)){
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
        }
        $fp = fopen('call.log', 'a');
        fwrite($fp, 'user:' . $UserID. "\n");
        // 更新CallWaiter 表
        $sql = "insert into CallWaiter (user, session) values(" . $UserID . ", '" . $_POST['Session'] . "') on duplicate key update updateAt= now();";
        fwrite($fp, $sql . "\n");
        $ret = DBMethodUtils::RunSql($sql);

        //获取呼叫状态
        $sql = "select a.id, a.device, b.Dev_Name as name, a.status, a.waiter, a.wsPort from IpCall a inner join DeviceList b on b.DevID=a.device ";
        if($status === 0){ // 监听新的呼叫
            $sql .= "where a.status = 'ringing' and a.waiter is null and a.direction='d2s' and a.id > $id order by a.id asc limit 1;";
        }
        else { //监听特定ID的呼叫
            $sql .= "where a.id=" . $id . ";";
        }
        fwrite($fp, $sql . "\n");
        fclose($fp);
        $call = DBMethodUtils::findData($sql);
        //没有新的呼叫
        if($call == null){
			echo $this->PackResponseData ( ErrcodeUtil::$IPCALL_IDLE, '没有呼叫', null );
            return;
        }
        //填写了waiter，表明管理员接听了呼叫
        if(!is_null($call['waiter'])){
            $sql = "select id from CallWaiter where session='" . $_POST['Session'] . "' and user=$UserID and id=" . $call['waiter'] . ";";
            //接听呼叫的不是自己，返回错误
            $waiter = DBMethodUtils::findData($sql);
            if($waiter == null){
			    echo $this->PackResponseData ( ErrcodeUtil::$IPCALL_ACCEPTED_BY_OTHER, '呼叫已被他人接听!', null );
                return;
            }
        }
        //返回成功
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $call);
    }
}
