<?php
class ADeviceUtils {
	
	/**
	 * 获取设备分组
	 * @param $UserId
	 */
	public static function LoadDeviceClassTree($UserId) {
		
		//		$DeviceSql = "SELECT Parent, COUNT(*) AS DeviceCount FROM DeviceList";
		//		
		//		$DeviceSql .= " GROUP BY Parent";
		//		$sql = "SELECT ClassID AS id,Name AS text, a.Parent, IF(ISNULL(DeviceCount), 0, DeviceCount) AS DeviceCount, 'closed' AS state FROM DevClasses a 
		//			LEFT JOIN (" . $DeviceSql . ") b ON a.ClassID = b.Parent ORDER BY a.Parent, a.ClassID";
		

		$sql = "SELECT ClassID AS id,Name AS text, a.Parent, 'closed' AS state, b.DC FROM DevClasses a
			LEFT JOIN (SELECT COUNT(*) AS DC, Parent FROM DeviceList";
		
		if (! is_null ( $UserId ) && $UserId > 0) {
			$sql .= DeviceUtil::GetUserCtrDevSql ( " WHERE DevID ", $UserId );
		}
		$sql .= " GROUP BY Parent) b ON a.ClassID = b.Parent
 			ORDER BY a.Parent, a.ClassID";
		$data = DBMethodUtils::listData ( $sql );
		
		$bta = new BuildTreeArray ( $data, 'id', 'Parent', null );
		$data = $bta->getTreeArray ();
		
		return $data;
	}
	
	public static function DealDeviceClassTree($Tree) {
		
		if (empty ( $Tree )) {
			return array ();
		}
		$Out = array ();
		
		foreach ( $Tree as $item ) {
			if (empty ( $item ['children'] )) { //没有子节点
				if (is_null ( $item ['DC'] ) || $item ['DC'] <= 0) { //
					continue;
				}
			} else {
				$Children = ADeviceUtils::DealDeviceClassTree ( $item ['children'] );
				
				if (empty ( $Children )) {
					if (is_null ( $item ['DC'] ) || $item ['DC'] <= 0) { //
						continue;
					}
				}
				$item ['children'] = $Children;
			}
			$Out[] = $item;
		}
		
		return $Out;
	}
	
	/**
	 * 获取设备（按分组） 
	 * @param $UserId
	 * @param $forFQ 是否是分区专用
	 */
	public static function LoadDeviceTree($UserId, $forFQ = false) {
		
		$sql = 'SELECT DevID, Dev_Name, Parent FROM DeviceList';
		$hasWhere = false;
		
		if (! is_null ( $UserId ) && $UserId > 0) {
			$sql .= DeviceUtil::GetUserCtrDevSql ( " WHERE DevID ", $UserId );
			$hasWhere = true;
		}
		if ($forFQ) {
			if ($hasWhere) {
				$sql .= " AND LEFT(DevID, 2) != '38'";
			} else {
				$sql .= " WHERE LEFT(DevID, 2) != '38'";
			}
		}
		
		
		$devices = DBMethodUtils::listData ( $sql );
		
		$sql = 'select ClassID as id,Name as text, Parent, 0 as IsDevice, "closed" AS state from DevClasses';
		$deviceClasses = DBMethodUtils::listData ( $sql );
		
		// 没有父节点的设备
		$NoParentDev = array ();
		// 有父节点的设备
		$HasParentDev = array ();
		
		// 设备按照父节点分类
		if (! is_null ( $devices )) {
			foreach ( $devices as $item ) {
				if (is_null ( $item ['Parent'] ) || ! is_numeric ( $item ['Parent'] )) {
					// 是根节点
					$NoParentDev [count ( $NoParentDev )] = array ('id' => $item ['DevID'], 'text' => $item ['Dev_Name'], 'Parent' => $item ['Parent'], 'IsDevice' => '1' );
				} else {
					// 不是根节点
					$param = null;
					if (isset ( $HasParentDev [$item ['Parent']] )) {
						$param = $HasParentDev [$item ['Parent']];
					}
					if (is_null ( $param )) {
						$param = array ();
					}
					$param [count ( $param )] = array ('id' => $item ['DevID'], 'text' => $item ['Dev_Name'], 'Parent' => $item ['Parent'], 'IsDevice' => '1' );
					$HasParentDev [$item ['Parent']] = $param;
				}
			}
		}
		// 设备分类处理
		$classArr = new BuildTreeArray ( $deviceClasses, 'id', 'Parent', 0 );
		$DeviceClassArr = $classArr->getTreeArray ();
		$DeviceClassArr = is_null ( $DeviceClassArr ) ? array () : $DeviceClassArr;
		$DeviceClassArr = DeviceUtil::PackDeviceTree ( $DeviceClassArr, $HasParentDev );
		$DeviceClassArr = is_null ( $DeviceClassArr ) ? array () : $DeviceClassArr;
		
		// 处理顶级设备
		foreach ( $NoParentDev as $item ) {
			$DeviceClassArr [count ( $DeviceClassArr )] = $item;
		}
		
		return DeviceUtil::dealDeviceTree ( $DeviceClassArr );
	}
}