<?php
class ALogUtils {
	/**
	 * 获取设备日志列表sql
	 */
	public static function getListDeviceLogSql($UserID, $DataParam, &$ParamArr) {
		
		// 需要查询日志的设备ID，格式：1，2，3；查询全部日志则不传递参数
		$deviceID = "";
		
		if (isset ( $DataParam ['DeviceIDs'] )) {
			$deviceID = $DataParam ['DeviceIDs'];
		}
		// 日志开始时间,年月日；2015-12-24
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		
		// 日志结束时间,年月日；2015-12-24
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		$beginTime = date ( 'Y-m-d', strtotime ( $beginTime ) ) . ' 00:00:00';
		$endTime = date ( 'Y-m-d', strtotime ( $endTime ) ) . ' 23:59:59';
		
		// 日志类型，格式：1，2，3；全部则不用传值
		$Event = '';
		
		if (! empty ( $DataParam ['Event'] )) {
			$Event = $DataParam ['Event'];
		}
		$sql = "SELECT a.DevLogID, a.DeviceID AS DevID, IF(ISNULL(b.Dev_Name) OR LENGTH(b.Dev_Name) <= 0, IF(a.DeviceID like '38%' or '30%', d.SessionName, a.DeviceID),b.Dev_Name) AS Dev_Name,
			 a.CtrlUser,  c.User_Name, c.User_Desc, a.DateTime, a.EndTime, ";
		$sql .= " UNIX_TIMESTAMP(a.EndTime) - UNIX_TIMESTAMP(a.DateTime) AS Duration, a.Event ";
		$sql .= " FROM DeviceLog a LEFT JOIN DeviceList b on a.DeviceID=b.DevID LEFT JOIN Users c on a.CtrlUser = c.User_ID";
        $sql .= " LEFT JOIN PlaySessions d on a.DeviceID=d.PlayerID";
		$sql .= " WHERE DateTime >=:beginTime AND DateTime<=:endTime";
		
		$ParamArr [':beginTime'] = $beginTime;
		$ParamArr [':endTime'] = $endTime;
		
//		if (! is_null ( $UserID ) && $UserID > 0) {
//			$sql .= DeviceUtil::GetUserCtrDevSql ( " AND DeviceID ", $UserID );
//		}
		//设备id
		if (! empty ( $deviceID )) {
			$sql .= " AND DeviceID IN(:DeviceID)";
			$ParamArr [':DeviceID'] = $deviceID;
		}
		//事件
		if (! empty ( $Event )) {
			$arr = explode(",", $Event);
			$tempArr = array();
			
			foreach ($arr as $item) {
				if (is_numeric($item)) {
					$tempArr[] = $item;
				}
			}
			if (empty($tempArr)) {
				return "";
			}
			$sql = $sql . " AND Event IN(" . implode(",", $tempArr) . ")";
		} else {
			return "";
		}
		
		//搜索
		if (! empty ( $DataParam ['searchKey'] )) {
			$searchKey = $DataParam ['searchKey'];
			$sql .= " AND (a.DeviceID LIKE CONCAT('%', :searchKey, '%') OR b.Dev_Name LIKE CONCAT('%', :searchKey1, '%') OR c.User_Desc LIKE CONCAT('%', :searchKey2, '%'))";
			
			$ParamArr [':searchKey'] = $searchKey;
			$ParamArr [':searchKey1'] = $searchKey;
			$ParamArr [':searchKey2'] = $searchKey;
		}
		
		return $sql;
	}
	
	/**
	 * 获取能耗统计sql
	 * @param $UserId
	 * @param $DataParam
	 */
	public static function getListDeviceEnergySql($UserID, $DataParam, &$ParamArr) {
		
		// 需要查询日志的设备ID，格式：1，2，3；查询全部日志则不传递参数
		$deviceID = "";
		
		if (isset ( $DataParam ['DeviceIDs'] )) {
			$deviceID = $DataParam ['DeviceIDs'];
		}
		
		// 日志开始时间
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		
		// 日志结束时间
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		$beginTime = date ( 'Y-m-d', strtotime ( $beginTime ) ) . ' 00:00:00';
		$endTime = date ( 'Y-m-d', strtotime ( $endTime ) ) . ' 23:59:59';
		
		// 时间类型，1：小时，2：分钟，默认：1
		$TimeType = 1;
		
		if (isset ( $DataParam ['TimeType'] )) {
			$TimeType = $DataParam ['TimeType'];
		}
		if (! in_array ( $TimeType, array (1, 2 ) )) {
			$TimeType = 1;
		}
		
		$sql = "SELECT a.DeviceID, IF(ISNULL(b.Dev_Name) OR LENGTH(b.Dev_Name) <=0, a.DeviceID, b.Dev_Name) AS Dev_Name, a.PowerConsumed, a.UsedTime FROM DeviceStatistic a";
		$sql .= " LEFT JOIN DeviceList b ON b.DevID = a.DeviceID ";

//        $User = Users::model ()->findByPk ( $UserID );
//        if (! is_null ( $UserID ) && $UserID > 0 && $User['Mgr_Privilege'] != 1) {
//			$sql .= " RIGHT JOIN UserDevices c ON UserID = :UserID AND a.DeviceID = c.DevID AND Pri & " . SystemUtil::getUserDevMask ( "1" ) . " > 0";
//			$ParamArr[':UserID'] = $UserID;
//		}
		$sql .= " WHERE sp_dev_belong_group( a.DeviceID , 0) = true and a.StatisticDay >= :beginTime and a.StatisticDay < :endTime";
		$ParamArr[':beginTime'] = $beginTime;
		$ParamArr[':endTime'] = $endTime;
		
		if (! empty ( $deviceID )) {
			$sql .= " AND a.DeviceID IN(" . $deviceID . ")";
		}
		$sql .= "  Order by Dev_Name";
		
		return $sql;
	}
	
	/**
	 * 用户操作日志sql
	 * @param $UserID
	 * @param $DataParam
	 */
	public static function getListUserOptLogSql($UserID, $DataParam, &$ParamArr) {
		
		// 需要查询日志的设备ID，格式：1，2，3；查询全部日志则不传递参数
		$deviceID = "";
		
		if (isset ( $DataParam ['DeviceIDs'] )) {
			$deviceID = $DataParam ['DeviceIDs'];
		}
		// 日志开始时间,年月日；2015-12-24
		$beginTime = "";
		
		if (isset ( $DataParam ['BeginTime'] )) {
			$beginTime = $DataParam ['BeginTime'];
		}
		
		// 日志结束时间,年月日；2015-12-24
		$endTime = "";
		
		if (isset ( $DataParam ['EndTime'] )) {
			$endTime = $DataParam ['EndTime'];
		}
		$beginTime = date ( 'Y-m-d', strtotime ( $beginTime ) ) . ' 00:00:00';
		$endTime = date ( 'Y-m-d', strtotime ( $endTime ) ) . ' 23:59:59';
		
		//操作用户id
		$CtrlUser = null;
		
		if (isset ( $DataParam ['CtrlUser'] )) {
			$CtrlUser = $DataParam ['CtrlUser'];
		}
		$sql = "SELECT a.DevLogID, a.DeviceID AS DevID, IF(ISNULL(b.Dev_Name) OR LENGTH(b.Dev_Name) <= 0, a.DeviceID,b.Dev_Name) AS Dev_Name, a.CtrlUser, c.User_Sn, c.User_Name, c.User_Desc, a.DateTime, a.EndTime, ";
		$sql .= " UNIX_TIMESTAMP(a.EndTime) - UNIX_TIMESTAMP(a.DateTime) AS Duration, a.Event, a.MsgContext ";
		$sql .= " FROM DeviceLog a LEFT JOIN DeviceList b on a.DeviceID=b.DevID LEFT JOIN Users c on a.CtrlUser = c.User_ID";
		$sql .= ' WHERE a.CtrlUser >= 0 AND DateTime >=:beginTime AND DateTime<= :endTime';
		
		$ParamArr[':beginTime'] = $beginTime;
		$ParamArr[':endTime'] = $endTime;

//        if (! is_null ( $UserID ) && $UserID > 0) {
//            $sql .= DeviceUtil::GetUserCtrDevSql ( " AND b.DevID", $UserID );
//        }

        //用户id
		if (! empty ( $CtrlUser ) && $CtrlUser > 0) {
			$sql .= ' AND a.CtrlUser = :CtrlUser';
			$ParamArr[':CtrlUser'] = $CtrlUser;
		}
		
		//搜索
		if (! empty ( $DataParam ['searchKey'] )) {
			$searchKey = $DataParam ['searchKey'];
			$sql .= " AND (a.DeviceID LIKE CONCAT('%', :searchKey, '%') OR b.Dev_Name LIKE CONCAT('%', :searchKey1, '%') OR c.User_Sn LIKE CONCAT('%', :searchKey2, '%') OR c.User_Desc LIKE CONCAT('%', :searchKey3, '%'))";
			$ParamArr [':searchKey'] = $searchKey;
			$ParamArr [':searchKey1'] = $searchKey;
			$ParamArr [':searchKey2'] = $searchKey;
			$ParamArr [':searchKey3'] = $searchKey;
		}
		
		return $sql;
	}
	
	/**
	 * 处理能耗统计
	 * @param $result
	 */
	public static function dealPowerStatistic($result) {
		
		//key：设备id，value：设备能耗
		$tempArr = array ();
		
		foreach ( $result as $item ) {
			$devSta = array ();
			
			if (isset ( $tempArr [$item ['DeviceID']] )) {
				$devSta = $tempArr [$item ['DeviceID']];
			}
			$devSta ['DeviceID'] = $item ['DeviceID']; // 设备id
			$devSta ['Dev_Name'] = $item ['Dev_Name']; // 设备名字
			$devPwr = array ();
			
			if (isset ( $devSta ['pwr'] )) {
				$devPwr = $devSta ['pwr'];
			}
			if (empty ( $devPwr )) {
				for($i = 0; $i <= 31; $i ++) {
					$devPwr [$i] = 0;
				}
			}
			$devTime = array ();
			
			if (isset ( $devSta ['time'] )) {
				$devTime = $devSta ['time'];
			}
			if (empty ( $devTime )) {
				for($i = 0; $i <= 31; $i ++) {
					$devTime [$i] = 0;
				}
			}
			$PowerConsumed = bin2hex ( $item ['PowerConsumed'] ); // 32路能耗统计，每4个字节对应一个无符号32位的整数，0路表示中控整机 1路表示投影机 2～15 ID2到ID15的控制器能耗统计 16～31预留
			$UsedTime = bin2hex ( $item ['UsedTime'] ); // 32路时长统计，每4个字节对应一个无符号32位的整数，0路表示中控整机 1路表示投影机 2～15 ID2到ID15的控制器时间统计 16～31预留
			
			$PowerConsumedArr = array ();
			$UsedTimeArr = array ();
			
			for($i = 0; $i < 128; $i ++) {
				$PowerConsumedArr [] = hexdec ( substr ( $PowerConsumed, $i * 2, 2 ) );
				$UsedTimeArr [] = hexdec ( substr ( $UsedTime, $i * 2, 2 ) );
			}
			
			if (isset ( $tempArr [$item ['DeviceID']] )) {
				for($i = 0; $i < 32; $i ++) {
					$devPwr [$i] += $PowerConsumedArr [($i << 2) + 3] + ($PowerConsumedArr [($i << 2) + 2] << 8) + ($PowerConsumedArr [($i << 2) + 1] << 16) + ($PowerConsumedArr [$i << 2] << 24);
					$devTime [$i] += $UsedTimeArr [($i << 2) + 3] + ($UsedTimeArr [($i << 2) + 2] << 8) + ($UsedTimeArr [($i << 2) + 1] << 16) + ($UsedTimeArr [$i << 2] << 24);
				}
			} else {
				for($i = 0; $i < 16; $i ++) {
					$devPwr [$i] += $PowerConsumedArr [($i << 2) + 3] + ($PowerConsumedArr [($i << 2) + 2] << 8) + ($PowerConsumedArr [($i << 2) + 1] << 16) + ($PowerConsumedArr [$i << 2] << 24);
					$devTime [$i] += $UsedTimeArr [($i << 2) + 3] + ($UsedTimeArr [($i << 2) + 2] << 8) + ($UsedTimeArr [($i << 2) + 1] << 16) + ($UsedTimeArr [$i << 2] << 24);
				}
			}
			$devSta ['pwr'] = $devPwr;
			$devSta ['time'] = $devTime;
			
			$tempArr [$item ['DeviceID']] = $devSta;
		}
		
		return $tempArr;
	}

	//	/**
//	 * 处理能耗统计
//	 * @param  $i 从1到30
//	 * @param  $value
//	 */
//	public static function getPwrValue($arr, $i, $value) {
//		
//		echo "------" . $value . "===>" . strlen ( $value ) . "-----------";
//		
//		//		echo $i;
//		//		print_r($arr);
//		//		echo $i . "---" . ToolUtil::shr32 ( ToolUtil::shl32 ( $value, 64 * $i ), 64 * (32 - $i) ) . '====>' .   hexdec ( ToolUtil::shr32 ( ToolUtil::shl32 ( $value, 64 * $i ), 64 * (32 - $i) ) ) . '--->';
//		
//
//		$val = (isset ( $arr [$i] ) ? $arr [$i] : 0) + hexdec ( ToolUtil::shr32 ( ToolUtil::shl32 ( $value, 64 * $i ), 64 * (32 - $i) ) );
//		
//		return $val;
//	}


}
