<?php
class ToolUtil {
	public static function ConvertToUTF8($text) {
		
		$encoding = mb_detect_encoding ( $text, mb_detect_order (), false );
		
		if ($encoding == "UTF-8") {
			$text = mb_convert_encoding ( $text, 'UTF-8', 'UTF-8' );
		}
		
		$out = iconv ( mb_detect_encoding ( $text, mb_detect_order (), false ), "UTF-8//IGNORE", $text );
		
		return $out;
	}
	
	/**
	 * 将 字符串转换成UTF的格式
	 * @param $mixed 原始字符串
	 */
	public static function charsetToUTF8($mixed) {
		
		if (is_array ( $mixed )) {
			foreach ( $mixed as $k => $v ) {
				if (is_array ( $v )) {
					$mixed [$k] = ToolUtil::charsetToUTF8 ( $v );
				} else {
					//					$encode = mb_detect_encoding ( $v, array ('ASCII', 'UTF-8', 'GB2312', 'GBK', 'BIG5' ) );
					//					if ($encode == 'EUC-CN') {
					//						$mixed [$k] = mb_convert_encoding ( $v, 'UTF-8' ); //iconv ( 'GBK', 'UTF-8', $v );
					//					}
					$mixed [$k] = ToolUtil::ConvertToUTF8 ( $v );
				}
			}
		} else {
			$encode = mb_detect_encoding ( $mixed, array ('ASCII', 'UTF-8', 'GB2312', 'GBK', 'BIG5' ) );
			
			if ($encode == 'EUC-CN') {
				$mixed = mb_convert_encoding ( $mixed, 'UTF-8', 'GBK' ); //iconv ( 'GBK', 'UTF-8', $mixed );
			} else {
				$mixed = ToolUtil::ConvertToUTF8 ( $mixed );
			}
		}
		
		return $mixed;
	}
	
	/**
	 * 字符串转换成gb2132格式
	 * @param $mixed
	 */
	public static function charsetToGb2132($mixed) {
		
		if (is_array ( $mixed )) {
			foreach ( $mixed as $k => $v ) {
				if (is_array ( $v )) {
					$mixed [$k] = ToolUtil::charsetToUTF8 ( $v );
				} else {
					$encode = mb_detect_encoding ( $v, array ('ASCII', 'UTF-8', 'GB2312', 'GBK', 'BIG5' ) );
					
					$mixed [$k] = mb_convert_encoding ( $v, "GB2312", $encode );
				}
			}
		} else {
			$encode = mb_detect_encoding ( $mixed, array ('ASCII', 'UTF-8', 'GB2312', 'GBK', 'BIG5' ) );
			
			$mixed = mb_convert_encoding ( $mixed, "GB2312", $encode );
		}
		
		return $mixed;
	}
	
	/**
	 * 访问状态
	 */
	public static function accessStatus() {
	
	}
	
	/**  
	 * 无符号32位右移  
	 * @param mixed $x 必须是十六进制的字符串
	 * @param string $bits 右移位数  
	 * @return mixed 结果，如果超出整型范围将返回浮点数  
	 */
	public static function shr32($x, $bits) {
		// 位移量超出范围的两种情况   
		if ($bits <= 0) {
			return $x;
		}
		$l = strlen ( $x );
		
		if ($bits >= $l * 4) {
			return '0';
		}
		if ($bits % 4 == 0) {
			//十六进制的整数倍
			$res = substr ( $x, 0, $l - round ( $bits / 4 ) );
			
			return $res;
		} else {
			//不是4的整数倍
			$res = substr ( $x, 0, $l - round ( $bits / 4 ) - 1 );
			$diwei = substr ( $res, strlen ( $res ) - 1, 1 );
			$diwei = $diwei & pow ( 2, $bits % 4 );
			
			return $res . bin2hex ( $diwei );
		}
	}
	
	/**  
	 * 无符号32位左移  
	 * @param mixed $x 必须是十六进制的字符串
	 * @param string $bits 左移位数  
	 * @return mixed 结果，如果超出整型范围将返回浮点数  
	 */
	public static function shl32($x, $bits) {
		// 位移量超出范围的两种情况   
		if ($bits <= 0) {
			return $x;
		}
		$l = strlen ( $x );
		
		if ($bits >= $l * 4) {
			return '0';
		}
		//转换成代表二进制数字的字符串   
		//		$bin = decbin ( $x );
		if ($bits % 4 == 0) {
			//十六进制的整数倍
			$res = substr ( $x, round ( $bits / 4 ) );
			for($i = 0; $i < round ( $bits / 4 ); $i ++) {
				$res .= "0";
			}
			
			return $res;
		} else {
			//不是4的整数倍
			$res = substr ( $x, round ( $bits / 4 ) + 1 );
			$gaowei = substr ( $x, round ( $bits / 4 ), 1 );
			$gaowei = $gaowei & pow ( 2, $bits % 4 );
			
			return bin2hex ( $gaowei ) . $res;
		}
	}
	
	/**
	 * 十六进制转字符串
	 * @param $hex
	 */
	public static function hexToStr($hex) {
		$string = "";
		for($i = 0; $i < strlen ( $hex ) - 1; $i += 2)
			$string .= chr ( hexdec ( $hex [$i] . $hex [$i + 1] ) );
		return $string;
	}
	
	/**
	 * 十进制转字符串
	 * @param $hex
	 */
	public static function decToStr($dec) {
		
		$string = "";
		
		for($i = 0; $i < count ( $dec ) - 1; $i ++) {
			$tempArr = array_slice ( $dec, $i );
			$arr = array_count_values ( $tempArr );
			
			ToolUtil::writeLog ( CJSON::encode ( $arr ) );
			
			if (count ( $tempArr ) == $arr [0]) {
				break;
			}
			$string .= chr ( hexdec ( dechex ( $dec [$i] ) ) );
		}
		return $string;
	}
	
	/**
	 * 十进制转二进制
	 * @param $hex
	 */
	public static function decToBin($dec, $padnum = 8) {
		$string = "";
		for($i = 0; $i < count ( $dec ) - 1; $i ++)
			$string .= str_pad ( dechex ( $dec [$i] ), $padnum, "0", STR_PAD_LEFT ); //不足一个字节长度，自动前面补充0 
		return $string;
	}
	
	/**
	 * 十进制转十六进制
	 * @param $hex
	 */
	public static function decToHex($dec, $padnum = 2) {
		$string = "";
		$arr = array ();
		$i = 0;
		
		foreach ( $dec as $item ) {
			//			if ($i == 0) {
			//				$arr [] = dechex ( $item ); //不足一个字节长度，自动前面补充0 
			//			} else {
			$arr [] = str_pad ( dechex ( $item ), $padnum, "0", STR_PAD_LEFT ); //不足一个字节长度，自动前面补充0 
			//			}
			$i ++;
		}
		$size = count ( $arr );
		$i = 0;
		
		for(; $i < $size; $i ++) {
			$break = true;
			$j = $i;
			
			for(; $j < $size; $j ++) {
				if ("00" != $arr [$j]) {
					$break = false;
					break;
				}
			}
			if ($break) {
				break;
			}
			$item = $arr [$i];
			$string .= $item;
		}
		
		return $string;
	}
	
	/**
	 * 字符串获取byte数组
	 * @param $string
	 */
	public static function getb2132Bytes($string) {
		
		$string = ToolUtil::charsetToGb2132 ( $string );
		
		$bytes = array ();
		
		if (! is_null ( $string )) {
			for($i = 0; $i < strlen ( $string ); $i ++) {
				$bytes [] = ord ( $string [$i] );
			}
		}
		
		return $bytes;
	}
	
	/**
	 * 字符串获取byte数组
	 * @param $string
	 */
	public static function getBytes($string) {
		
		$bytes = array ();
		
		if (! is_null ( $string )) {
			if (strlen ( $string ) % 2 != 0) { //不是2的倍数
				$string = '0' . $string;
			}
			
			for($i = 0; $i < strlen ( $string ) - 1; $i = $i + 2) {
				$bytes [] = hexdec ( $string [$i] . $string [$i + 1] );
			}
		}
		//		//1.列出每个字符
		//		$bytes = preg_split ( '/(?<!^)(?!$)/u', $string );
		//		//2.unpack字符
		//		foreach ( $bytes as &$v ) {
		//			$temp = unpack ( 'H*', $v );
		//			$v = base_convert ( $temp [1], 16, 2 );
		//			unset ( $temp );
		//		}
		//		return join ( ' ', $arr );
		

		return $bytes;
	}
	
	/**
	 * 获取设置的语言
	 * @param $lang
	 */
	public static function GetLanguage($lang) {
		
		/**
		 * 可以不用区分大小写
		 * en : 英文
		 * zh_cn：简体中文
		 */
		$langearr = array ('uk', 'zh_cn' );
		
		if (! in_array ( strtolower ( $lang ), $langearr )) {
			$lang = 'zh_cn';
		}
		
		return $lang;
	}
	
	/**
	 * 读写语言
	 * @param $lang 语言
	 * @param $read 是否是读取
	 */
	public static function WriteOrReadLanguage($lang, $UserID, $read = false) {
		
		if ($read) {
			if (file_exists ( "protected/runtime/language_" . $UserID )) {
				$file = fopen ( "protected/runtime/language_" . $UserID, "r" );
				$lang = trim ( fgets ( $file ) );
				fclose ( $file );
			}
			$lang = ToolUtil::GetLanguage ( $lang );
		} else {
			$lang = ToolUtil::GetLanguage ( $lang );
			//保存文件
			$file = fopen ( "protected/runtime/language_" . $UserID, "w" );
			fwrite ( $file, strtolower ( $lang ) );
			fclose ( $file );
		}
		
		return $lang;
	}
	
	/**
	 * 判断时间格式
	 * @param $time
	 */
	public static function JudgeTimeFormat($time) {
		
		if (is_null ( $time ) || trim ( $time ) == '') {
			return false;
		}
		$arr = explode ( ':', $time );
		
		if (is_null ( $arr ) || count ( $arr ) != 3) {
			return false;
		}
		if (! is_numeric ( $arr [0] ) || $arr [0] < 0 || $arr [0] >= 24) { //时 0 - 23
			return false;
		}
		if (! is_numeric ( $arr [1] ) || $arr [1] < 0 || $arr [1] > 59) { //分 0 - 59
			return false;
		}
		if (! is_numeric ( $arr [2] ) || $arr [2] < 0 || $arr [2] > 59) { //秒 0 - 59
			return false;
		}
		
		return true;
	}
	
	/**
	 * 读写文件
	 * @param unknown_type $Content
	 * @param unknown_type $Path
	 * @param unknown_type $read
	 */
	public static function WriteOrReadFile($Content, $Path, $read = false) {
		
		if ($read) {
			if (file_exists ( $Path )) {
				$file = fopen ( $Path, "r" );
				$Content = trim ( fgets ( $file ) );
				fclose ( $file );
			}
		} else {
			//保存文件
			$file = fopen ( $Path, "w" );
			fwrite ( $file, strtolower ( $Content ) );
			fclose ( $file );
		}
		
		return $Content;
	}
	
	public static function microtime_float() {
		list ( $usec, $sec ) = explode ( " ", microtime () );
		return (( float ) $usec + ( float ) $sec);
	}
	
	/**
	 * 获得用户的真实IP地址
	 *
	 * @access  public
	 * @return  string
	 */
	public static function GetClientIp() {
		
		static $realip = NULL;
		
		if ($realip !== NULL) {
			return $realip;
		}
		
		if (isset ( $_SERVER )) {
			if (isset ( $_SERVER ['HTTP_X_FORWARDED_FOR'] )) {
				$arr = explode ( ',', $_SERVER ['HTTP_X_FORWARDED_FOR'] );
				
				/* 取X-Forwarded-For中第一个非unknown的有效IP字符串 */
				foreach ( $arr as $ip ) {
					$ip = trim ( $ip );
					
					if ($ip != 'unknown') {
						$realip = $ip;
						
						break;
					}
				}
			} else if (isset ( $_SERVER ['HTTP_CLIENT_IP'] )) {
				$realip = $_SERVER ['HTTP_CLIENT_IP'];
			} else {
				if (isset ( $_SERVER ['REMOTE_ADDR'] )) {
					$realip = $_SERVER ['REMOTE_ADDR'];
				} else {
					$realip = '0.0.0.0';
				}
			}
		} else {
			if (getenv ( 'HTTP_X_FORWARDED_FOR' )) {
				$realip = getenv ( 'HTTP_X_FORWARDED_FOR' );
			} else if (getenv ( 'HTTP_CLIENT_IP' )) {
				$realip = getenv ( 'HTTP_CLIENT_IP' );
			} else {
				$realip = getenv ( 'REMOTE_ADDR' );
			}
		}
		preg_match ( "/[\d\.]{7,15}/", $realip, $onlineip );
		$realip = ! empty ( $onlineip [0] ) ? $onlineip [0] : '0.0.0.0';
		
		return $realip;
	}
	
	/**
	 * 获取本机的真实内网Ip
	 */
	public static function GetMyIp() {
		
		//		if (PHP_SAPI === 'cli') {
		$buffer = "";
		$handle = popen ( "ifconfig eth0|grep 'inet addr'|awk -F'[ :]' '{print $13}'", 'r' );
		while ( ! feof ( $handle ) ) {
			$buffer .= fgets ( $handle );
		}
		pclose ( $handle );
		$server_ip = rtrim ( $buffer );
		
		if (empty ( $server_ip )) {
			$buffer = "";
			$handle = popen ( "ifconfig eth1|grep 'inet addr'|awk -F'[ :]' '{print $13}'", 'r' );
			while ( ! feof ( $handle ) ) {
				$buffer .= fgets ( $handle );
			}
			pclose ( $handle );
			$server_ip = rtrim ( $buffer );
		}
		//		} else {
		//			if (isset ( $_SERVER )) {
		//				if ($_SERVER ['SERVER_ADDR']) {
		//					$server_ip = $_SERVER ['SERVER_ADDR'];
		//				} else {
		//					$server_ip = $_SERVER ['LOCAL_ADDR'];
		//				}
		//			} else {
		//				$server_ip = getenv ( 'SERVER_ADDR' );
		//			}
		//		}
		

		return $server_ip;
	}
	
	/**
	 * 处理树形结构
	 * @param $Tree
	 */
	public static function DealTree($Tree) {
		
		if (empty ( $Tree )) {
			return $Tree;
		}
		$Out = array ();
		
		foreach ( $Tree as $key => $value ) {
			if (empty ( $value ['children'] )) {
				unset ( $value ['state'] );
			} else {
				$value ['children'] = ToolUtil::DealTree ( $value ['children'] );
			}
			$Out [] = $value;
		}
		
		return $Out;
	}
	
	/**
	 * 获取有效的的数组
	 * @param  $str 原始数据，用分隔符分开
	 * @param  $split 分隔符
	 * @param  $isNumber 是否是数字
	 */
	public static function getValidData($str, $split, $isNumber = false) {
		
		if (is_null ( $str )) {
			return array ();
		}
		$Arr = explode ( $split, $str );
		
		if (empty ( $Arr )) {
			return array ();
		}
		$OutArr = array ();
		
		foreach ( $Arr as $item ) {
			
			if ($isNumber) {
				if (is_numeric ( $item )) {
					$OutArr [] = $item;
				}
			} else {
				$OutArr [] = $item;
			}
		}
		
		return $OutArr;
	}
	
	/**
	 * 判断域名合法性
	 * @param $tdl
	 */
	public static function CheckTLD($tdl) {
		
		$arr = explode ( '.', $tdl );
		
		if (count ( $arr ) < 2) {
			return false;
		}
		
		foreach ( $arr as $value ) {
			if (strlen ( $value ) <= 2) {
				if (preg_match ( "/^[a-z0-9]{1,2}$/i", $value ) == 0) {
					return false;
				}
			} else if (preg_match ( "/^[a-z0-9][a-z0-9\-]+[a-z0-9]$/i", $value ) == 0) {
				return false;
			}
		}
		
		return true;
	}
	
	public static function writeLog($msg) {
		
	    $file = fopen ( "Log.txt", "a" );
		
	    fwrite ( $file, date ( 'Y-m-d H:i:s' ) . "\t\t\t" . $msg . "\r\n" );
	    fclose ( $file );
	}

}
